var params;
var mitexto="";
//var baseurl=".wiktionary.org/w/api.php?action=query&prop=revisions&rvprop=content&rvexpandtemplates=true&format=json&titles=";
var baseurl=".wiktionary.org/w/api.php?action=parse&format=json&uselang=en&prop=text|images&page=";
var history=[];

function loadDictionary(p){
	document.getElementById('addnoteaction').hide();
	document.getElementById('backaction').hide();
	params=p;
	$('#text').val(params.text);
	
	var o=localStorage.getItem("dict_lang_from");
	if(!o){
		o="en";
	}
	var fromdown = document.getElementById('language');
	switch(o){
	case "es":
		fromdown.setSelectedItem(1);
		break;
	case "en":
		fromdown.setSelectedItem(0);
		break;
	case "fr":
		fromdown.setSelectedItem(2);
		break;
	}
}

function addNoteFromDictionary(){
	if($('#results').text().trim().length>0){
		var tempo={};
		tempo.page=book.currentPage;
		tempo.npage=book.currentNPages;
		tempo.pointer=book.currentPointer;
		tempo.label=$('#results').text();
		tempo.date=new Date().getTime();
		tempo.position=params.position;
		
		var color=localStorage.getItem("note-color");
		if(!color)
			color="#FFFF00";
		state=color.substring(1);
		state=parseInt("0x"+state, 16);
		tempo.color=state;
		
		params.book.notes.push(tempo);
		params.book.lastsynced=book.lastsynced+1;
		params.book.saveBook();
		cloudsync.saveBookNotes(params.book);
		Toast.regular($.localize.data['app'].noteaddedfromdictionary, 3000);
	}
}

function processText(){
	var lang=$('#language').val();
	var baseURL="http://"+lang+".wiktionary.org";
	$('#results').find('a:not(.references a):not(.extiw):not([href^="#"])').attr('href',
			function() { return baseURL + $(this).attr('href');
	});
	
	$('#results').find('a:not(.references a):not(.extiw):not([href^="#"])').each(function(i) {
		var href=$(this).attr('href');
		var title=$(this).attr('title');
		if(title!=""){
			$(this).click(function() {
				var title=$(this).attr('title');
				$('#text').val(title);
				searchdictionary();
			});
			$(this).attr('href', "#");
		}else{
			//url 
		}
	});

	if(history.length>1){
		document.getElementById('backaction').show();
	}else{
		document.getElementById('backaction').hide();
	}
}
function goBack(){
	console.log("GO BACK");
	if(history.length>1){
		console.log("GO BACK YES");
		history.splice(history.length-1, 1);//este es el actual, lo desprecio
		var temp=history[history.length-1];
		console.log("GO BACK", temp);
		$('#Spinner').show();
		setTimeout(function(){
			$('#results').html(temp.html);
			$('#text').val(temp.texto);
			document.getElementById('addnoteaction').show();
			processText();
			$('#Spinner').hide();
		}, 200);
	}
}
function searchdictionary(){
	var lang=$('#language').val();
	mitexto=$('#text').val();
	
	document.getElementById('addnoteaction').hide();
	localStorage.setItem("dict_lang_from", $('#language').val());
	$('#Spinner').show();
	
	var temp=mitexto.split(" ");
	if(temp.length>2){
		mitexto=temp[0];
	}

	var textoabuscar=mitexto.toLowerCase();
	var url="http://"+lang+baseurl+escape(textoabuscar);
	console.log(url);
	$('#results').html('');
	document.getElementById('addnoteaction').hide();
	
	 $.ajax({
		 type: 'GET',
		 url: url,
		 dataType: "json",
		 data: { 
		    },
		 success: function(data) {
			 console.log(data);
			 if(data.error){
				$('#results').html("<h1><u><strong>"+textoabuscar+"</strong></u></h1>\n<p>"+$.localize.data['app'].searchnotfound+"</p>");
				history.push({"texto": $('#text').val(), "html": $('#results').html()});
				$('#Spinner').hide();
			 }else{
				$('#results').html(data.parse.text['*']);
				$('#Spinner').hide();
				document.getElementById('addnoteaction').show();
				
				history.push({"texto": $('#text').val(), "html": data.parse.text['*']});
				processText();
			 }
		 },
		 error: function(data) {
			 console.log(data);
		 }
	});
}