cloudsync={
		pin:blackberry.identity.uuid,
		device:blackberry.system.hardwareId,
		epub: null,
		url:"https://sync.playepub.com/",
		token:"",
		cloudSyncUsername:"",
		cloudSyncPassword:"",
		
		Sync: function(alert){
			var o=localStorage.getItem("push_token");
			if(o){
				token=o;
			}
			if(alert && (pin=="" || pin==null)){
				/*
				var a:AlertDialog=new AlertDialog();
				a.title="Permission error";
				a.message="You have not granted Device Identifying permission, we can't configure automatic sync without it.\nPlease, close Playepub, grant permission and open again.";
				a.addButton(bundle.getResource("close"));
				a.show();
				*/
			}
		}, 
		setSchedule: function (action, time){
			if(this.isConnected() && this.pin!=null){
				var syncurl=this.url+"sync.php";
				 $.ajax({
					 type: 'POST',
					 url: syncurl,
					 data: { 
					        'action': action, 
					        'pin': this.pin,
					        'device': this.device,
					        'token': localStorage.getItem("push_token"),
					        'hora': time,
					    },
					 
					 success: function(data) {
						 cloudsync.completeHandlerSchedule(data);
					 },
					 error: function(data) {
						 console.log('Error updating status: ' + data.responseText);
						 cloudsync.securityErrorHandler();
					 }
				});
			}else{
				this.dispatchKO();
			}
		},
		completeHandlerSchedule: function (res){
			if(res.substr(0, 2)=="OK"){
				this.dispatchOK();
			}else{
				this.dispatchKO();
			}
		}, 
		
		login: function (u, p){
			var syncurl=this.url+"books.php";
			
			 $.ajax({
				 type: 'POST',
				 url: syncurl,
				 data: { 
				        'action': "login", 
				        'pin': this.pin,
				        'device': this.device,
				        'username': u,
				        'password': p,
				    },
				 success: function(data) {
					 console.log(data);
					 console.log("LOGIN RESULT "+data);
					 cloudsync.completeLoginHandler(data);
				 },
				 error: function(data) {
					 console.log(data);
					 console.log('Error updating status: ' + data.responseText);
					 cloudsync.securityErrorHandler();
				 }
			});
		}, 
		changepass: function (u, p, newp){
			var syncurl=this.url+"books.php";

			 $.ajax({
				 type: 'POST',
				 url: syncurl,
				 
				 data: { 
				        'action': "changepass", 
				        'pin': this.pin,
				        'device': this.device,
				        'username': u,
				        'password': p,
				        'newpassword':newp
				    },
				 success: function(data) {
					 cloudsync.completeLoginHandler(data);
				 },
				 error: function(data) {
					 console.log('Error updating status: ' + data.responseText);
					 cloudsync.securityErrorHandler();
				 }
			});
		},
		
		resetPassword: function(u){
			var syncurl=this.url+"books.php";

			 $.ajax({
				 type: 'POST',
				 url: syncurl,
				 
				 data: { 
				        'action': "resetpassword", 
				        'pin': this.pin,
				        'device': this.device,
				        'username': u,
				    },
				 success: function(data) {
					 cloudsync.completeLoginHandler(data);
				 },
				 error: function(data) {
					 console.log('Error updating status: ' + data.responseText);
					 cloudsync.securityErrorHandler();
				 }
			});
		},
		completeLoginHandler: function(res) {
			if(res.substr(0, 2)=="OK"){
				this.dispatchOK();
			}else{
				this.dispatchKO();
			}
		},
		
		saveBook: function(b, lastPosition){
			if(!cloudsync.isEnabled())
				return;
			
			if(this.isConnected()){
				var syncurl=this.url+"books.php";
				var o={};
				o.position=b.currentPage+"|"+b.currentNPages+"|"+b.currentPointer+"|"+b.useBookStyles;
				o.realposition=lastPosition;
				o.bookmarks=b.bookmarks;
				o.notes=b.notes;
				o.highlights=b.highlights;

				 $.ajax({
					 type: 'POST',
					 url: syncurl,
					 
					 data: { 
					        'action': "set", 
					        'pin': this.pin,
					        'device': this.device,
					        'username': this.cloudSyncUsername,
					        'password': this.cloudSyncPassword,
					        'idbook':b.identifier,
					        'hora': new Date().time, 
					        'title': b.title,
					        'author': b.autor,
					        'book':JSON.stringify(o)
					    },
					 success: function(data) {
						 cloudsync.completeHandler(data);
					 },
					 error: function(data) {
						 console.log('Error updating status: ' + data.responseText);
						 cloudsync.securityErrorHandler();
					 }
				});
			}else{
				this.dispatchKO();
			}
		},
		
		saveBookPosition: function(b, lastPosition){
			if(!this.isEnabled())
				return;

			if(this.isConnected()){
				book=b;
				var syncurl=this.url+"books.php";
				var o={};
				o.position=b.currentPage+"|"+b.currentNPages+"|"+b.currentPointer+"|"+b.useBookStyles;
				o.realposition=lastPosition;
				
				 $.ajax({
					 type: 'POST',
					 url: syncurl,
					 
					 data: { 
					        'action': "setPosition", 
					        'pin': this.pin,
					        'device': this.device,
					        'username': this.cloudSyncUsername,
					        'password': this.cloudSyncPassword,
					        'idbook':b.identifier,
					        'hora': new Date().time, 
					        
					        'title': b.titulo,
					        'author': b.autor,
					        'book':JSON.stringify(o)
					    },
					 success: function(data) {
						 cloudsync.completeHandler(data);
					 },
					 error: function(data) {
						 console.log('Error updating status: ' + data.responseText);
						 cloudsync.securityErrorHandler();
					 }
				});
			}else{
				this.dispatchOK();
			}
		},
		saveBookBookmarks: function(b){
			if(!this.isEnabled())
				return;

			if(this.isConnected()){
				book=b;
				var syncurl=this.url+"books.php";
				var o={};
				o.bookmarks=b.bookmarks;
				
				 $.ajax({
					 type: 'POST',
					 url: syncurl,
					 
					 data: { 
					        'action': "setBookmarks", 
					        'pin': this.pin,
					        'device': this.device,
					        'username': this.cloudSyncUsername,
					        'password': this.cloudSyncPassword,
					        'idbook':b.identifier,
					        'hora': new Date().time, 
					        'title': b.titulo,
					        'author': b.autor,
					        'book':JSON.stringify(o)
					    },
					 success: function(data) {
						 cloudsync.completeHandler(data);
					 },
					 error: function(data) {
						 console.log('Error updating status: ' + data.responseText);
						 cloudsync.securityErrorHandler();
					 }
				});
			}else{
				this.dispatchKO();
			}
		},
		saveBookNotes: function(b){
			if(!this.isEnabled())
				return;

			if(this.isConnected()){
				book=b;
				var syncurl=this.url+"books.php";
				var o={};
				o.notes=b.notes;
				
				 $.ajax({
					 type: 'POST',
					 url: syncurl,
					 
					 data: { 
					        'action': "setNotes", 
					        'pin': this.pin,
					        'device': this.device,
					        'username': this.cloudSyncUsername,
					        'password': this.cloudSyncPassword,
					        'idbook':b.identifier,
					        'hora': new Date().time, 
					        'title': b.titulo,
					        'author': b.autor,
					        'book':JSON.stringify(o)
					    },
					 success: function(data) {
						 cloudsync.completeHandler(data);
					 },
					 error: function(data) {
						 console.log('Error updating status: ' + data.responseText);
						 cloudsync.securityErrorHandler();
					 }
				});
			}else{
				this.dispatchKO();
			}
		},
		saveBookHighlights: function(b){
			if(!this.isEnabled())
				return;

			if(this.isConnected()){
				book=b;
				var syncurl=this.url+"books.php";
				var o={};
				o.highlights=b.highlights;
				
				 $.ajax({
					 type: 'POST',
					 url: syncurl,
					 
					 data: { 
					        'action': "setHighlights", 
					        'pin': this.pin,
					        'device': this.device,
					        'username': this.cloudSyncUsername,
					        'password': this.cloudSyncPassword,
					        'idbook':b.identifier,
					        'hora': new Date().time, 
					        'title': b.titulo,
					        'author': b.autor,
					        'book':JSON.stringify(o)
					    },
					 success: function(data) {
						 cloudsync.completeHandler(data);
					 },
					 error: function(data) {
						 console.log('Error updating status: ' + data.responseText);
						 cloudsync.securityErrorHandler();
					 }
				});
			}else{
				this.dispatchKO();
			}
		},
		getBookList: function(){
			if(this.isEnabled() && this.isConnected()){
				var syncurl=this.url+"books.php";
				
				 $.ajax({
					 type: 'POST',
					 url: syncurl,
					 data: { 
					        'action': "getBooksList", 
					        'pin': this.pin,
					        'device': this.device,
					        'username': this.cloudSyncUsername,
					        'password': this.cloudSyncPassword,
					        'idbook':0,
					    },
					 success: function(data) {
						 cloudsync.bookListLoaded(data);
					 },
					 error: function(data) {
						 console.log('Error updating status: ' + data.responseText);
						 cloudsync.securityErrorHandler();
					 }
				});
			}else{
				this.dispatchKO();
			}
		},
		
		allbooks:[],
		onBooksLoaded:function(books){},
		bookListLoaded: function(res) {
			try{
				allbooks=JSON.parse(res);
				for(var i=0; i<allbooks.length; i++){
					allbooks[i].label=allbooks[i].title;
				}
				this.onBooksLoaded(allbooks);
			}catch(e){
				this.dispatchKO();
			}
		},
		
		delBook: function(bookid, id){
			if(this.isEnabled() && this.isConnected()){
				var syncurl=this.url+"books.php";

				 $.ajax({
					 type: 'POST',
					 url: syncurl,
					 
					 data: { 
					        'action': "delBook", 
					        'pin': this.pin,
					        'device': this.device,
					        'username': this.cloudSyncUsername,
					        'password': this.cloudSyncPassword,
					        'idbook':bookid,
					        'id':id,
					    },
					 success: function(data) {
						 cloudsync.bookDeleted(data);
					 },
					 error: function(data) {
						 console.log('Error updating status: ' + data.responseText);
						 cloudsync.securityErrorHandler();
					 }
				});
			}else{
				this.dispatchKO();
			}
		},
		bookDeleted: function(res) {
			if(res.substr(0, 2)=="OK"){
				cloudsync.dispatchOK();
			}else{
				cloudsync.dispatchKO();
			}
		},
		book:null, //reader
		getBook: function(b){
			if(!cloudsync.isEnabled())
				return;

			if(this.isConnected()){
				book=b;
				var syncurl=this.url+"books.php";
				
				 $.ajax({
					 type: 'POST',
					 url: syncurl,
					 
					 data: { 
					        'action': "get", 
					        'pin': this.pin,
					        'device': this.device,
					        'username': this.cloudSyncUsername,
					        'password': this.cloudSyncPassword,
					        'idbook':b.identifier,
					        'hora':new Date().time,
					    },
					 success: function(data) {
						 cloudsync.bookLoaded(data);
					 },
					 error: function(data) {
						 console.log('Error updating status: ' + data.responseText);
						 cloudsync.securityErrorHandler();
					 }
				});
			}else{
				cloudsync.dispatchKO();
			}
		},
		loadedinfo:{},
		/*
		getLastRealPosition: function(){
			if(loadedinfo.realposition){
				var s=loadedinfo.realposition;
				var o=null;
				if(loadedinfo.realposition!="")
					o=JSON.parse(s);

				var str=loadedinfo.position;
				var temp=str.split("|");
				
				var tempo={};
				tempo.page=temp[0];
				tempo.npage=temp[1];
				tempo.pointer=parseInt(temp[2]);
				tempo.label="Page "+(Number(book.getActualPagePage())+1);
				tempo.fontsize=book.fontsize;
				tempo.id="";
				tempo.position=o;
				//saveManager.setProperty(book.identifier, loadedinfo.position);
				book.refreshSavedData();
				return tempo;
			}
			return null;
		},
		*/
		bookLoaded: function(res) {
			try{
				var last=book.lastsynced;
				loadedinfo=JSON.parse(res);
				if(loadedinfo.lastupdate!=0 && loadedinfo.lastupdate>last){
			        blackberry.ui.dialog.standardAskAsync($.localize.data['app'].cloudsyncnewer, blackberry.ui.dialog.D_OK_CANCEL, function(sel){
					    if(sel['return']=="Ok"){
					    	cloudsync.dispatchPosition(loadedinfo);
					    }else{
					    	//si no actualizo el remoto actualizo el local
							cloudsync.dispatchSaveFull();
					    }
			        }, {title : "Cloud sync"});
				}else if(loadedinfo.lastupdate==0){//inicializo el libro si nunca ha sido cargado
					//cloudsync.dispatchPosition(loadedinfo);
					cloudsync.dispatchUpdateCurrent();
				}else if(loadedinfo.lastupdate<last){//lo que tengo esta mas actualizado que lo remoto
					cloudsync.dispatchUpdateCurrent();
				}else{
					cloudsync.dispatchOK();
				}
			}catch(e){
				//trace(e.toString());
				cloudsync.dispatchKO();
			}
		},
		dispatchSaveFull: function(){},
		dispatchPosition: function(){},
		dispatchOK: function(){},
		dispatchKO: function(){},
		dispatchUpdateCurrent: function(){},

		completeHandler: function(res) {
			if(res.substr(0, 2)=="OK"){
				res=res.replace("OK ", "");
				var last=parseInt(res)+0;
				console.log("last: ", last);
				if(last>0 && book){//actualizo la ultima actualizacion
					book.lastsynced=last;
					book.saveBook();
				}
				cloudsync.dispatchOK();
			}else{
				cloudsync.dispatchKO();
			}
		},
		securityErrorHandler: function() {
			//trace("securityErrorHandler: " + event);
			cloudsync.dispatchKO();
		},
		ioErrorHandler: function(event) {
			//trace("ioErrorHandler: " + event);
			cloudsync.dispatchKO();
		},
		isEnabled: function(){
			var usecloud=(localStorage.getItem("useCloudSync") == "true");
			this.cloudSyncUsername=localStorage.getItem("cloudSyncUsername");
			this.cloudSyncPassword=localStorage.getItem("cloudSyncPassword");
			console.log("SYNC CREDENTIALS: "+this.cloudSyncUsername+" "+this.cloudSyncPassword);
			return (usecloud && this.cloudSyncUsername!="" && this.cloudSyncPassword!="");
		},
		isConnected: function(){
			console.log("CONNECTION TYPE: "+blackberry.connection.type);
			//return (NetworkManager.networkManager.isConnected());
			return (blackberry.connection.type!=blackberry.connection.NONE);
		}
	};