Instapaper={
		key:"4ND0iDvCawfxrzXSGNPCNJBrXZEBRuqr5SauC1yS8sNZcte7e6",
		secret:"KGsqpiWFa8YFpwlU9fh1guxDh8sQaQCT5G0esL0YWi4q8H0Xam",
		username:"",
		password:"",
		
		request_token_url:"https://www.instapaper.com/api/1/oauth/access_token",
		reading_url:'https://www.instapaper.com/api/1/bookmarks/list',
		gettext_url:'https://www.instapaper.com/api/1/bookmarks/get_text',
		archive_url:'https://www.instapaper.com/api/1/bookmarks/archive',
		
		_consumer:null,
		//protected var signature:OAuthSignatureMethod_HMAC_SHA1 = new OAuthSignatureMethod_HMAC_SHA1();
		accessToken:null,
		identifier:"Instapaper",
		redits:[],
		pointer:0,
		isAuth:false,
		canceled:false,
		
		init:function(u, pass){
			this.username=localStorage.getItem("instapaper_username");
			this.password=localStorage.getItem("instapaper_password");

			if(u!="")
				this.username=u;
			if(pass!="")
				this.password=pass;
			
			var ikey=localStorage.getItem("instapaper_key");
			var iSecret=localStorage.getItem("instapaper_secret");
			this.accessToken={key: ikey, secret: iSecret};
			
			if(ikey && iSecret){
				this.isAuth=true;
			}
		},
		checkCredentials: function(){
			this.auth();
		},
		
		consumer:function(){
			if ( this._consumer == null && key != null && secret != null ) {
				this._consumer = new OAuthConsumer( key, secret );
			}
			return this._consumer;
		},
		authOK:function(){},
		authKO:function(){},
		authNotSubscriber:function(){},
		syncComplete: function(){},
		auth:function(){
			var accessor = {
			  //token: "...",
			  //tokenSecret: "...",
			  consumerKey : this.key,
			  consumerSecret: this.secret,
			};

			var message = {
			  action: this.request_token_url,
			  method: "POST",
			  parameters: {
				  "x_auth_username": this.username,
				  "x_auth_password": this.password,
				  "x_auth_mode": "client_auth"
			  }
			};

			OAuth.completeRequest(message, accessor);        
			OAuth.SignatureMethod.sign(message, accessor);
			//url = url + '?' + OAuth.formEncode(message.parameters);
			var params={};
			for(var p in OAuth.getParameterList(message.parameters)){
				var param=OAuth.getParameterList(message.parameters)[p];
				params[param[0]]=param[1];
			}
			console.log(params);
			 $.ajax({
				 type: 'POST',
				 data: params,
				 url: this.request_token_url,
				 success: function(data) {
					 console.log(data);
					 Instapaper.requestTokenHandler(data);
				 },
				 error: function(data) {
					 console.log(data);
					 Instapaper.authKO();
				 }
			});
		},

		requestTokenHandler: function(data) {
			this.accessToken = this.getTokenFromResponse(data);

			localStorage.setItem("instapaper_key", this.accessToken.key);
			localStorage.setItem("instapaper_secret", this.accessToken.secret);
			//this.verify_credentials();
			localStorage.setItem("instapaper_username", this.username);
			localStorage.setItem("instapaper_password", this.password);
			this.authOK();
		},
		getTokenFromResponse: function(tokenResponse){
			var result = {};
			
			var params = tokenResponse.split( "&" );
			for( var i in params ) {
				var param=params[i];
				var paramNameValue = param.split( "=" );
				if ( paramNameValue.length == 2 ) {
					if ( paramNameValue[0] == "oauth_token" ) {
						result.key = paramNameValue[1];
					} else if ( paramNameValue[0] == "oauth_token_secret" ) {
						result.secret = paramNameValue[1];
					}
				}
			}
			return result;
		},
		/*
		verify_credentials: function(){
			var url="https://www.instapaper.com/api/1/account/verify_credentials";
			var accessor = {
					  token: this.accessToken.key,
					  tokenSecret: this.accessToken.secret,
					  consumerKey : this.key,
					  consumerSecret: this.secret,
					};

			var message = {
			  action: url,
			  method: "POST",
			  parameters: {}
			};

			OAuth.completeRequest(message, accessor);        
			OAuth.SignatureMethod.sign(message, accessor);
			var params={};
			for(var p in OAuth.getParameterList(message.parameters)){
				var param=OAuth.getParameterList(message.parameters)[p];
				params[param[0]]=param[1];
			}
			console.log(params);
			 $.ajax({
				 type: 'POST',
				 data: params,
				 url: url,
				 success: function(data) {
					 console.log(data);
					 Instapaper.verify_credentialsOK(data);
				 },
				 error: function(data) {
					 console.log(data);
					 Instapaper.authKO();
				 }
			});
		},
		verify_credentialsOK: function(o){
			if(o[0].type!="user"){
				this.authKO();
			}else if(o[0].subscription_is_active!="1"){
				this.authNotSubscriber();
			}else{
				localStorage.setItem("instapaper_username", this.username);
				localStorage.setItem("instapaper_password", this.password);
				this.authOK();
			}
		},
		 */
		listAll: function() {
			this.redits=[];
			var accessor = {
			  token: this.accessToken.key,
			  tokenSecret: this.accessToken.secret,
			  consumerKey : this.key,
			  consumerSecret: this.secret,
			};

			var message = {
			  action: this.reading_url,
			  method: "POST",
			  parameters: {
				  limit: 100
			  }
			};

			OAuth.completeRequest(message, accessor);        
			OAuth.SignatureMethod.sign(message, accessor);
			var params={};
			for(var p in OAuth.getParameterList(message.parameters)){
				var param=OAuth.getParameterList(message.parameters)[p];
				params[param[0]]=param[1];
			}
			console.log(params);
			 $.ajax({
				 type: 'POST',
				 data: params,
				 url: this.reading_url,
				 success: function(data) {
					 console.log(data);
					 Instapaper.listAllOK(data);
				 },
				 error: function(data) {
					 console.log(data);
					 Instapaper.authKO();
				 }
			});
		},
		listAllOK:function(js){
			if(!this.canceled){
				this.pointer=0;
				for(var i in js){
					var o=js[i];
					if(o.hasOwnProperty("bookmark_id")){
						this.redits.push(o);
					}
				}
				
				if(this.redits.length>0){
					this.fetchArtichle();
				}else{
					this.syncComplete();
				}
			}
		},
		fetchArtichle: function(){
			console.log(this.canceled);
			if(!this.canceled){
				console.log(this.pointer+" => "+this.redits.length);
				if(this.pointer<this.redits.length && !this.canceled){
					var o=this.redits[this.pointer];
					
					var accessor = {
					  token: this.accessToken.key,
					  tokenSecret: this.accessToken.secret,
					  consumerKey : this.key,
					  consumerSecret: this.secret,
					};
	
					var message = {
					  action: this.gettext_url,
					  method: "POST",
					  parameters: {
						  bookmark_id: o['bookmark_id']
					  }
					};
	
					OAuth.completeRequest(message, accessor);        
					OAuth.SignatureMethod.sign(message, accessor);
					var params={};
					for(var p in OAuth.getParameterList(message.parameters)){
						var param=OAuth.getParameterList(message.parameters)[p];
						params[param[0]]=param[1];
					}
					console.log(params);
					 $.ajax({
						 type: 'POST',
						 data: params,
						 url: this.gettext_url,
						 success: function(data) {
							 //console.log(data);
							 Instapaper.fetchArtichleOK(data);
						 },
						 error: function(data) {
							 console.log(data);
							 Instapaper.authKO();
						 }
					});
				}else{
					this.savebook();
				}
			}else{
				console.log("CANCELED");
				this.syncComplete();
			}
		},
		fetchArtichleOK:function(data) {
			this.redits[this.pointer].data=data;
			this.pointer++;
			//var ev:InstapaperEvent=new InstapaperEvent(InstapaperEvent.ArticleGOT, false);
			this.fetchArtichle();
		},
		markasRead: function(bookmark_id){
			var archive=localStorage.getItem("instapaper_del");
			if(archive){
				var accessor = {
						  token: this.accessToken.key,
						  tokenSecret: this.accessToken.secret,
						  consumerKey : this.key,
						  consumerSecret: this.secret,
						};

						var message = {
						  action: this.gettext_url,
						  method: "POST",
						  parameters: {
							  'bookmark_id': bookmark_id
						  }
						};

						OAuth.completeRequest(message, accessor);        
						OAuth.SignatureMethod.sign(message, accessor);
						var params={};
						for(var p in OAuth.getParameterList(message.parameters)){
							var param=OAuth.getParameterList(message.parameters)[p];
							params[param[0]]=param[1];
						}
						 $.ajax({
							 type: 'POST',
							 data: params,
							 url: this.gettext_url,
							 success: function(data) {
								 //console.log(data);
							 },
							 error: function(data) {
								 console.log(data);
							 }
						});
			}
		},
		savebook:function(){
			if(!this.canceled){
				var images=localStorage.getItem("reditlater_download_images");
				
				var book=new NewBook("Instapaper", "Instapaper", "");
				book.setCover("local://assets/coverinstapaper.png");
				book.setBooksFolder(booksFolder);
				book.setDownloadImages((images == "true"));
				var archive=localStorage.getItem("instapaper_del");
				
				var order=0;
				
				for(var i in this.redits){
					var o=this.redits[i];
					var file={};
					file.title=o.title;
					file.url=o.url;
					file.html='<div><h1><a href="'+o.url+'">'+o.title+'</a></h1>'+o.data+'</div>';
					file.id=o.bookmark_id+".html";
					file.contentType="text/plain";
					book.addFile(file);
					
					var temp={};
					temp.src=o.bookmark_id+".html";
					temp.label=o.title;
					temp.playOrder=order;
					temp.size=file.html.length;
					
					book.addSpine(temp);
					order++;
					
					if(archive)
						this.markasRead(o.bookmark_id);
				}
				book.creationComplete=function(){
					Instapaper.syncComplete();
				};
				book.createBook();
			}else{
				this.syncComplete();
			}
		},
		cancel:function(){
			this.canceled=true;
		}
	};
