Pocket={
		apikey:"c5cAdEfRdb2cUT63c7p7ePQN17TUWdi7",
		username:"",
		password:"",
		identifier:"ReaditLater",
		redits:[],
		pointer:0,
		canceled:false,
		isAuth:false,
		
		init:function (u, pass){
			this.username=localStorage.getItem("reditlater_username");
			this.password=localStorage.getItem("reditlater_password");
			if(this.username && this.password){
				this.isAuth=true;
			}

			if(u)
				this.username=u;
			if(pass)
				this.password=pass;
		},
		cancel:function(){
			this.canceled=true;
		},
		loginOK:function(){},
		loginKO:function(){},
		syncComplete:function(){},
		doLogin:function(){
			var url="https://readitlaterlist.com/v2/auth?apikey="+this.apikey+"&username="+this.username+"&password="+this.password+"&";
			 $.ajax({
				 type: 'GET',
				 url: url,
				 success: function(data) {
					 console.log(data);
					 Pocket.doLoginOK(data);
				 },
				 error: function(data) {
					 console.log(data);
					 Pocket.loginKO();
				 }
			});
		},
		doLoginOK:function(data){
			if(data=="200 OK"){
				localStorage.setItem("reditlater_username", this.username);
				localStorage.setItem("reditlater_password", this.password);
				this.loginOK();
			}else{
				this.loginKO();
			}
		},
		
		fetchRedits:function(){
			var o=localStorage.getItem("reditlater_type");
			var state="";
			if(o){
				state=o;
				if(state!="all"){
					state="&state="+state;
				}else{
					state="";
				}
					
			}
			var url="https://readitlaterlist.com/v2/get?apikey="+this.apikey+"&username="+this.username+"&password="+this.password+state;
			 $.ajax({
				 type: 'GET',
				 url: url,
				 success: function(data) {
					 //console.log(data);
					 Pocket.fetchReditsOK(data);
				 },
				 error: function(data) {
					 console.log(data);
					 console.log('Error updating status: ' + data.responseText);
					 Pocket.loginKO();
				 }
			});

		},
		fetchReditsOK:function(o){
			try{
				var lista=o.list;
				for(var i in lista){
					this.redits.push(lista[i]);
				}
				pointer=0;
				if(this.redits.length>0){
					this.fetchArtichle();
				}else{
					this.syncComplete();	
				}
			}catch(e){
				this.syncComplete();	
			}
		},
		fetchArtichle:function(){
			if(!this.canceled){
				if(this.pointer<this.redits.length){
					var o=this.redits[this.pointer];
					var url="http://text.readitlaterlist.com/v2/text?apikey="+this.apikey+"&url="+o.url;
					 $.ajax({
						 type: 'GET',
						 url: url,
						 success: function(data) {
							 //console.log(data);
							 Pocket.fetchArtichleOK(data);
						 },
						 error: function(data) {
							 console.log(data);
							 console.log('Error updating status: ' + data.responseText);
							 Pocket.loginKO();
						 }
					});
				}else{
					this.savebook();
				}
			}else{
				this.syncComplete();
			}
		},
		fetchArtichleOK:function(data){
			this.redits[this.pointer].data=data;
			this.pointer++;
			this.fetchArtichle();
		},
		savebook:function(){
			if(!this.canceled){
				var images=localStorage.getItem("reditlater_download_images");
				
				var book=new NewBook("Pocket", "Pocket", "");
				book.setCover("local://assets/coverreaditlater.png");
				book.setBooksFolder(booksFolder);
				book.setDownloadImages((images == "true"));
				var order=0;
				
				for(var i in this.redits){
					var o=this.redits[i];
					var file={};
					file.title=o.title;
					file.url=o.url;
					file.html='<div><h1><a href="'+o.url+'">'+o.title+'</a></h1>'+o.data+'</div>';
					file.id=o.item_id+".html";
					file.contentType="text/plain";
					book.addFile(file);
					
					var temp={};
					temp.src=o.item_id+".html";
					temp.label=o.title;
					temp.playOrder=order;
					temp.size=file.html.length;
					
					book.addSpine(temp);
					order++;
				}
				var del=localStorage.getItem("reditlater_del");
				if(del)
					this.markasRead();
				
				book.creationComplete=function(){
					Pocket.syncComplete();
				};
				book.createBook();
			}else{
				this.syncComplete();
			}
		},
		markasRead:function(){
			var url="https://readitlaterlist.com/v2/send?apikey="+this.apikey+"&username="+this.username+"&password="+this.password+"&read=";
			var jo={};
			var punt=0;
			var myPattern = /\//g;
			for(var i in this.redits){
				var o=this.redits[i];
				jo[punt]={url: o.url.replace(myPattern, '/')};
				punt++;
			}
			url+=escape(JSON.stringify(jo));
			 $.ajax({
				 type: 'GET',
				 url: url,
				 success: function(data) {
					 console.log(data);
				 },
				 error: function(data) {
					 console.log(data);
				 }
			});
		},
};