var identifier="";
var bookdir="";
var parentfolder="";
var currentfolder="";
var filesortShow=0;
var searchShow=0;
var filesortField="name";

var lastBrowserElements=[];
var ZipFileSize=0;
var EntriesToUnzip;
var UnzipPunt=0;
var ZipExtracted=0;
var puntGetMetadata=0;
var entreiesGetMetadata;

function showHideSearch(){
	document.getElementById('sortdropdown').hide();
	if(searchShow){
		document.getElementById('searchtextfield').hide();
		searchShow=0;
	}else{
		searchShow=1;
		document.getElementById('searchtextfield').show();
	}
}
function showHideSort(){
	document.getElementById('searchtextfield').hide();
	if(filesortShow){
		document.getElementById('sortdropdown').hide();
		filesortShow=0;
	}else{
		filesortShow=1;
		document.getElementById('sortdropdown').show();
	}
}
function reload(){
	console.log("loadLocalStorage");
	getFolderList(currentfolder);
}
function loadLocalStorage(){
	console.log("loadLocalStorage");
	getFolderList("/accounts/1000/shared");
}
function loadSDcard(){
	console.log("loadSDcard");
	getFolderList(blackberry.io.SDCard);
}

function updateSortFiles(){
	filesortField=$('#sortdropdown').val();
	listResults(lastBrowserElements);
}
function listResults(entries) {
	if(filesortField=="name"){
		entries.sort(function(a, b){
			if(a.isDirectory && b.isDirectory){
			    if ( a.name.toLowerCase() < b.name.toLowerCase() )
			        return -1;
			    if ( a.name.toLowerCase() > b.name.toLowerCase() )
			        return 1;
			    return 0;
			}else if(a.isDirectory){
				return -1;
			}else if(b.isDirectory){
				return 1;
			}else{
			    if ( a.name.toLowerCase() < b.name.toLowerCase() )
			        return -1;
			    if ( a.name.toLowerCase() > b.name.toLowerCase() )
			        return 1;
			    return 0;
			}
		});
	}else{
		entries.sort(function(a, b){
			if(a.isDirectory && b.isDirectory){
			    if ( a.modificationTime < b.modificationTime )
			        return -1;
			    if ( a.modificationTime > b.modificationTime )
			        return 1;
			    return 0;
			}else if(a.isDirectory){
				return -1;
			}else if(b.isDirectory){
				return 1;
			}else{
			    if ( a.modificationTime < b.modificationTime )
			        return -1;
			    if ( a.modificationTime > b.modificationTime )
			        return 1;
			    return 0;
			}
		});
	}
	lastBrowserElements=entries;
	document.getElementById('browserlist').clear();	
	var item = document.createElement('div');
	
	if(currentfolder!="/accounts/1000/shared" && currentfolder!=blackberry.io.SDCard){
		item.setAttribute('data-bb-type','item');
		item.setAttribute('data-bb-title', "..");
		item.setAttribute('fullpath', parentfolder);
		item.setAttribute('isdirectory', "true");
		item.setAttribute('data-bb-img', 'assets/folder_black.png');
		item.onclick = clickFileItem;
		document.getElementById('browserlist').appendItem(item);
	}	
	
	//tengo que leer los metadatas y hacer un array con todo antes de procesarlos
	//asi tengo toda la info para esto y el filtrado y ordenado
	var index=0;
	for (index = 0; index < entries.length; ++index) {
		var entry=entries[index];

		item = document.createElement('div');
		item.setAttribute('data-bb-type','item');
		item.setAttribute('data-bb-title', entry.name);
		item.setAttribute('fullpath', entry.fullPath);
		item.setAttribute('isdirectory', entry.isDirectory);
		item.setAttribute('size', entry.size);
		
		//item.innerHTML = entry.name;
		if(entry.isDirectory){
			item.setAttribute('data-bb-img', 'assets/folder_black.png');
			bookok=true;
		}else{
			var ext=getFileExtension(entry.name);
			if(ext!=""){
				console.log(ext);
				if(validfiles.indexOf(ext)>=0){
					item.setAttribute('data-bb-img', 'assets/epub.png');
					item.innerHTML=sizeToStr(entry.size)+", "+entry.modificationTime.toLocaleString();
				}else{
					continue;
				}
			}else{
				continue;
			}
		}
		item.onclick = clickFileItem;

		// Append to list
		document.getElementById('browserlist').appendItem(item);
	};
}

function clickFileItem() {
	document.getElementById('sortdropdown').hide();
	var selected = document.getElementById('browserlist').selected;
	if(selected.getAttribute("isdirectory")=="true"){
		console.log(selected.getTitle());
		console.log(selected.getAttribute('fullpath'));
		getFolderList(selected.getAttribute('fullpath'));
	}else{
		var ext=getFileExtension(selected.getAttribute('data-bb-title'));
		
		switch(ext) {
		    case "epub":
				filesystem.root.getFile(selected.getAttribute('fullpath'), {}, function(fileEntry) {
					fileEntry.file(function(file) {
						ZipFileSize=selected.getAttribute('size');
						getFileIdentifier(fileEntry);
						console.log("Identifier: "+identifier);
						console.log("ZipFileSize "+ZipFileSize);
						booksFolder.getDirectory(identifier, {create: true}, function(dirEntry) {
							bookdir=dirEntry;
							readZip(file);
						  }, errorHandler);
				    }, errorHandler);
				  }, errorHandler);

		        break;
		    case "pdf":
		    	Toast.regular("Is PDF", 2000);
		        break;
		    case "fb2":
		    	Toast.regular("Is FB2", 2000);
		    	break;
		    case "mobi": 
		    case "prc":
		    case "azw":
		    case "pdb":
		    	Toast.regular("Is Kindle", 2000);
		    	break;
		} 
	}
};

function getFileIdentifier(tempfile){
	identifier=tempfile.name.replace("."+getFileExtension(tempfile.name), "")+ZipFileSize;

	var myPattern = /\W/g; 
	identifier=identifier.replace(myPattern, "");
	myPattern = /\n/g; 
	identifier=identifier.replace(myPattern, "");
	myPattern = /\r/g; 
	identifier=identifier.replace(myPattern, "");
	myPattern = /\//g; 
	identifier=identifier.replace(myPattern, "");
	myPattern = /\\/g; 
	identifier=identifier.replace(myPattern, "");
	
	if(identifier==""){
		identifier=Base64.encode(tempfile.fullpath);
	}
}

function readZip(blob){
	console.log("readZip");
	// use a BlobReader to read the zip from a Blob object
	zip.createReader(new zip.BlobReader(blob), function(reader) {
		console.log("reader creaes");
//tengo que crear primero el bookfolder para este libro!
		
		reader.getEntries(function(entries) {
			console.log("getentries");
			console.log(entries);
			//aqui tengo que calcular % de extraccion basado en tamaños
			if (entries.length) {
				$('#loading').show();
				$('#percentage').html("0%");
				$('#loadingtext1').html("Extracting file");
				UnzipPunt=0;
				ZipExtracted=0;
				EntriesToUnzip=entries;
				container="";
				doUnzipNext();
			}
		});
	}, function(error) {
	  console.log(error);
	});
}

function createDir(rootFolder, entry, folders) {
	rootFolder.getDirectory(folders[0], {create: true}, function(dirEntry) {
		folders=folders.slice(1);
	    if (folders.length>0) {
	    	createDir(dirEntry, entry, folders);
	    }else{
	    	createFile(entry);
	    }
	  }, errorHandler);
}
var container="";
function createFile(entry){
	bookdir.getFile(entry.filename, {create:true}, function(file) { 
		entry.getData(new zip.FileWriter(file), function(e) {
			if(entry.filename === "META-INF/container.xml") {
				file.file(function(file) {
			        var reader = new FileReader();
			        reader.onloadend = function(e) {
			          container = this.result;
			        };
			        reader.readAsText(file);
			     }, errorHandler);
			}
			ZipExtracted+=entry.compressedSize;
			doUnzipNext();
		}, function(current, total) {
			var pc=Math.floor((ZipExtracted+current)*100/ZipFileSize);
			//console.log(pc+"%"+" cu: "+current+" to: "+total);
			$('#percentage').html(pc+"%");
		}); 
	}, errorHandler);
}

var opfPath="";
function doUnzipNext(){
	if(UnzipPunt<EntriesToUnzip.length){
		entry=EntriesToUnzip[UnzipPunt];
		
		if(entry.directory){
			bookdir.getDirectory(entry.filename, {create:true}, function(file) {
				doUnzipNext();
			},
			function (error) {
	            console.log(error);
	        });
		}else{
			var folders=entry.filename.split('/');
			folders.pop();
			if(folders.length>0)
				createDir(bookdir, entry, folders);
			else
				createFile(entry);
		}
		UnzipPunt++;
	}else{
		console.log("EXTRACT END");
		if(container!=""){
			opfPath=getOpfPathFromContainer();
			console.log(opfPath);
			bookdir.getFile(opfPath, {create:false}, function(file) { 
				file.file(function(file) {
			        var reader = new FileReader();
			        reader.onloadend = function(e) {
			          opf = this.result;
			          readOpf(opf);
			        };
			        reader.readAsText(file);
			     }, errorHandler);
			}, errorHandler);
		}else{
			Toast.regular("There was an error open file", 2000);
		}
		$('#loading').hide();
	}
}
function readOpf(j) {
	var o = xmlDocument(j);
	var m = {
		metadata : {},
		manifest : {},
		spine : []
	};
	var l = o.getElementsByTagName("metadata")[0].childNodes;
	for (var h = 0, n = l.length; h < n; h++) {
		var f = l[h];
		if (f.nodeType === 3) {
			continue;
		}
		var p = {};
		for (var g = 0, c = f.attributes.length; g < c; g++) {
			var k = f.attributes[g];
			p[k.name] = k.value;
		}
		p._text = f.textContent;
		//si es meta
		if(f.nodeName=="meta"){
			if(p['name'] && p['content']){
				m.metadata[p['name']] = p['content'];
			}
		}else{
			if(f.textContent!="")
				m.metadata[f.nodeName] = p;
		}
	}
	var d = o.getElementsByTagName("manifest")[0].getElementsByTagName("item");
	for (var h = 0, n = d.length; h < n; h++) {
		var f = d[h];
		m.manifest[f.getAttribute("id")] = {
			href : resolvePath(f.getAttribute("href"), opfPath),
			"media-type" : f.getAttribute("media-type")
		};
	}
	var e = o.getElementsByTagName("spine")[0].getElementsByTagName("itemref");
	for (var h = 0, n = e.length; h < n; h++) {
		var f = e[h];
		m.spine.push(f.getAttribute("idref"));
	}
	opf = m;
	console.log(opf);
	
	var title="";
	var autor="";
	
	if(opf.metadata['dc:title'])
		title=opf.metadata['dc:title']._text;
	if(opf.metadata['dc:creator'])
		autor=opf.metadata['dc:creator']._text;
	
	var cover="";
	var mediajpeg="image/jpeg";
	var mediapng="image/png";
	
	if(opf.metadata['cover']){
		var mycover=opf.metadata['cover'];
		if(opf.manifest[mycover]){
			cover=opf.manifest[mycover].href;
		}
	}
	
	if(cover==""){
		if(opf.manifest['cover'] && (opf.manifest['cover']['media-type']==mediajpeg || opf.manifest['cover']['media-type']==mediapng)){
			cover=opf.manifest['cover'].href;
		}
	}
	if(cover==""){
		var firstmedia="";
		for(var item in opf.manifest){
			var it=opf.manifest[item];
			if(it['media-type']==mediajpeg || it['media-type']==mediapng){
				if(firstmedia=="")
					firstmedia=it.href;
				if(item.indexOf('cover')>=0 || it.href.indexOf('cover')>=0){
					cover=it.href;
					break;
				}
			}
		}
		if(cover==""){
			cover=firstmedia;
		}
	}
	
	if(cover!=""){
		cover="file://"+blackberry.io.home+"/books/"+identifier+"/"+cover;
	}
	var b=new Book();
	b.identifier=identifier;
	b.title=title;
	b.autor=autor;
	b.cover=cover;
	b.lastdate=0;
	b.isCollection=false;
	b.saveBook();
	
	getBooksList(false);
	if(opf.manifest.ncx){
		loadNcx(opf.manifest.ncx.href);
	}else if(opf.manifest.toc){
		loadNcx(opf.manifest.toc.href);
	}
	bb.popScreen();
}
function loadNcx(href){
	bookdir.getFile(href, {create:false}, function(file) { 
		file.file(function(file) {
	        var reader = new FileReader();
	        reader.onloadend = function(e) {
	            var nfc = xmlDocument(this.result);
	            var navpoints=nfc.getElementsByTagName("navMap")[0].getElementsByTagName("navPoint");
	            //navPoints=sortXMLList(navPoints, "@playOrder", Array.NUMERIC);
		  		console.log(navpoints);
		  		if (navPoints.length()>0) {
		  			pointsToc=[];
		  			for(var a in navPoints) {
		  				loadNcxItems(a, "");
		  			}
		  			//saveManager.setProperty(this.identifier+"_pointsToc", pointsToc);
		  		}
	        };
	        reader.readAsText(file);
	     }, errorHandler);
	}, errorHandler);
}
var pointsToc;
function loadNcxItems(a, indent){
	/*
	var temp={label:indent+a.navLabel.text,  src: a.content.@src, playOrder: a.@playOrder);
	console.log("NAVPOINT: "+temp.label);
	pointsToc.push(temp);
	
	var navPoints=a.getElementsByTagName("navPoint");
	if (navPoints.length()>0) {
		for (var b in navPoints) {
			loadNcxItems(b, indent+"          ");
		}
	}
	*/
}

function resolvePath(g, c) {
	var k = g.split("/");
	var j = k.pop();
	var h = c.split("/");
	h.pop();
	for (var f = 0, e = k.length; f < e; f++) {
		var d = k[f];
		if (d === "..") {
			h.pop();
		} else {
			h.push(d);
		}
	}
	h.push(j);
	return h.join("/");
}
function getOpfPathFromContainer() {
	var c = xmlDocument(container);
	return c.getElementsByTagName("rootfile")[0].getAttribute("full-path");
}

function xmlDocument(c) {
	var d = new DOMParser().parseFromString(c, "text/xml");
	if (d.childNodes[1] && d.childNodes[1].nodeName === "parsererror") {
		throw d.childNodes[1].childNodes[0].nodeValue;
	}
	return d;
}
			
function getFolderList(path){
	console.log("getFolderList "+path);
	currentfolder=path;
	localStorage.setItem("lastFileBrowserPath", currentfolder);
	filesystem.root.getDirectory(path, {},
        function (folder) {
			console.log("shared folder is found");
        	console.log(folder);
        	folder.getParent(
        			function(myparent){
        				console.log("sucess getting parent");
        				console.log(myparent);
        				parentfolder=myparent.fullPath;
        			}, 
        			function(error){
        				console.log("Error getting parent");
        				console.log(error);
        			}
        		); 
        	var dirReader = folder.createReader();
        	var entries = [];
        	
        	var readEntries = function() {
            	dirReader.readEntries (function(results) {
                	if (!results.length) {
                        console.log(entries);
                        getEntriesMetadata(entries);
                    } else {
                    	entries = entries.concat(toArray(results));
                    	readEntries();
                    }
             }, fail);
        	};
        	readEntries();
        	console.log(dirReader);
        },
        function (error) {
        	console.log("error with getting directory.");
            console.log(error);
        }
    );
}

function getEntriesMetadata(entries){
	entreiesGetMetadata=entries;
	puntGetMetadata=0;
	doNextGetEntriesMetadata();
}
function doNextGetEntriesMetadata(){
	if(puntGetMetadata<entreiesGetMetadata.length){
		var entry=entreiesGetMetadata[puntGetMetadata];
		entry.getMetadata(function(metadata) { 
		    console.log(metadata);
		    mymetadata=metadata;
		    entry.size=metadata.size;
		    entry.modificationTime=metadata.modificationTime;
		    entreiesGetMetadata[puntGetMetadata]=entry;
		    puntGetMetadata++;
		    doNextGetEntriesMetadata();
		});
	}else{
		console.log("metadatas done");
		listResults(entreiesGetMetadata);
	}
}

