var filesToImport=[];
var recursiveFolders=[];
var importSilent=false;
var importPunt=0;
var checkPunt=0;
var importErrors=[];
var completedBooks=0;
var doingImport=false;

function doAutomaticFolders(){
	var autos=localStorage.getObject("automaticFolders");
	if(autos && autos.length>0){
		console.log("procesing autofolders "+autos.length);
		importSilent=true;
		for(var i=0; i<autos.length; i++){
			recursiveFolders.push(autos[i]);
		}
		searchForBooksRecursive();
	}else{
		console.log("NO AUTO FOLDERS");
	}
}
function addNewBook(){
	var lastFolder=localStorage.getItem("lastFolder");
	if(!lastFolder)
		lastFolder=blackberry.io.shared;
	
	blackberry.invoke.card.invokeFilePicker(
			{
				mode: blackberry.invoke.card.FILEPICKER_MODE_PICKER,
				filter: validfilesExtensions,
				directory: [lastFolder]
			},
			function (path) {
				console.log(path);
				var temp=path[0].split("/");
				temp.pop();
				var parent=temp.join("/");
				
				localStorage.setItem("lastFolder", parent);
				filesToImport.push(path[0]);
				importSilent=false;
				if(!importSilent && filesToImport.length==1){
					document.getElementById('bulkprogress').hide();
				}
				$('#loading').show();
				checkifBooksExist();
				//if(!doingImport)
					//doImportAll();
			},
			function (reason) {
			},
			function (error) {
			}
		);
}

function bulkAddNewBook(){

	var lastFolder=localStorage.getItem("lastFolder");
	if(!lastFolder)
		lastFolder=blackberry.io.shared;
	

	filesToImport=[];
	blackberry.invoke.card.invokeFilePicker(
			{
				mode: blackberry.invoke.card.FILEPICKER_MODE_SAVER_MULTIPLE,
				directory: [lastFolder]
			},
			function (path) {
				importSilent=false;
				//if(!importSilent)
					document.getElementById('bulkprogress').show();
				console.log("import folder: "+path[0]);
				//preguntat si recursivo
				localStorage.setItem("lastFolder", path[0]);
				recursiveFolders=[path[0]];
				searchForBooksRecursive();
			},
			function (reason) {
			},
			function (error) {
			}
		);
}

function checkifBooksExist(){
	if(checkPunt>=0){
		var file=filesToImport[checkPunt];
		checkPunt--;
		filesystem.root.getFile(file, {},
		        function (fileEntry) {
					fileEntry.getMetadata(function(metadata){
					    var size=metadata.size;
						var identifier=getFileIdentifier(fileEntry.name)+size;
						var book=localStorage.getItem(identifier);
						if(book){
							//console.log("Excluding existing book "+fileEntry.name);
							filesToImport.splice((checkPunt+1), 1);
						}else{
						}
						checkifBooksExist();
					}, function(){
						checkifBooksExist();
					});
				},
		        function (error) {
					console.log(error);
		        	checkifBooksExist();
		        }
		);
	}else{
		checkPunt=0;
		if(!importSilent && filesToImport.length>0){
			document.getElementById('bulkprogress').show();
			$('#loading').show();
		}
		if(!doingImport)
			doImportAll();
	}
}
function searchForBooksRecursive(){
	if(recursiveFolders.length>0){
		var path=recursiveFolders.pop();
		console.log(path);
		console.log(filesystem);
		filesystem.root.getDirectory(path, {},
		        function (folder) {
		        	var myreader = folder.createReader();
		        	var entries = [];
		        	var readEntries = function() {
		        		myreader.readEntries (function(results) {
		                	if (!results.length) {
		                        for(var i in entries){
		                        	var folder=entries[i];
		                        	if(folder.isDirectory){
		                        		recursiveFolders.push(folder.fullPath);
		                        	}else{
		                        		var temp=folder.name.split(".");
		                				if(validfiles.indexOf(temp[temp.length-1])>=0){
		                					filesToImport.push(folder.fullPath);
		                				}
		                        	}
		                        }
                        		searchForBooksRecursive();
		                    } else {
		                    	entries = entries.concat(toArray(results));
		                    	readEntries();
		                    }
			             }, function(err){
			            		console.log(err);
			             });
		        	};
		        	readEntries();
		        },
		        function (error) {
		        	console.log("error with getting directory.");
		            console.log(error);
		            //si una localizacion da error pq no existe, continuamos
		            searchForBooksRecursive();
		        }
		);
	}else{
		if(filesToImport.length>0){
			checkPunt=filesToImport.length-1;
			checkifBooksExist();
		}else{
			doImportAll();
		}
	}
}
var ep=undefined;

function doImportAll(){
	console.log(filesToImport);
	if(importPunt<filesToImport.length){
		ep=undefined;
		doingImport=true;
		if(!importSilent){
			if(filesToImport.length==1){
				document.getElementById('bulkprogress').hide();
			}else{
				document.getElementById('bulkprogress').show();
			}
			document.getElementById('bulkprogress').setValue(Math.ceil((importPunt*100/filesToImport.length)));
			$('#loadingtext0 p').html($.localize.data['app'].importingfile+" "+(importPunt+1)+" "+$.localize.data['app'].of+" "+filesToImport.length);
		}		
		var file=filesToImport[importPunt];
		importPunt++;
		var ext=getFileExtension(file);
		if(!importSilent){
			document.getElementById('progress').setValue(0);
			$('#loading').show();
		}
		switch(ext){
		case "epub":
			try{
				ep=new Epub(file);
				ep.onComplete=onComplete;
				ep.onError=onError;
				ep.onProgress=onProgress;
				ep.onExistingBook=onExistingBook;
				ep.extract();
			}catch(e){
				onError(e);
			}
			break;
		case "fb2":
			ep=new Fb2(file);
			ep.onComplete=onComplete;
			ep.onError=onError;
			ep.onProgress=onProgress;
			ep.onExistingBook=onExistingBook;
			//try{
				ep.extract();
			//}catch(e){
			//	console.log("FB2 EXCEPTION");
			//	onError(e);
			//}
			break;
		case "mobi":
		case "prc":
		case "azw":
		case "pdb":
			//fake para hacer el control de archivo abierto
			ep=new Epub(file);
			ep.identifier=getFileIdentifier("");
			startMobiWorker(file);
			break;
		}
	}else{
		if(ep){
			lastImportedBooks=completedBooks;
			ep=undefined;
		}
		console.log("lastBookImported "+lastBookImported);
		console.log("finish import ", completedBooks);
		console.log("IMPORT ERRORS: ", importErrors);
		finishimport();
	}
}

function finishimport(){
	if(!importSilent){
		$('#loading').hide();
		if(importErrors.length>0){
			var errores=importErrors.join("<br>");
	        //alert($.localize.data['app'].errorimportingbooks+" \n"+errores);
	        var msg=$.localize.data['app'].errorimportingbooks+"<br><br>"+errores;
	        blackberry.ui.dialog.standardAskAsync(msg, blackberry.ui.dialog.D_OK, function(){}, {title : $.localize.data['app'].error});

		}
		if(completedBooks>0){
			Toast.regular(completedBooks+" "+$.localize.data['app'].booksimported, 3000);
		}
	}
	doingImport=false;
	filesToImport=[];
	recursiveFolders=[];
	importSilent=false;
	importPunt=0;
	importErrors=[];
	
	if(completedBooks>0){
		completedBooks=0;
		getBooksList(function(){
			console.log("IMPORT FINISHED");
			//solo refresco si estoy viendo la home
			if((currentScreen=="homelist" || currentScreen=="home") && lastImportedBooks==1 && lastBookImported!=null && lastBookImported!=""){
    			readBookProcess(lastBookImported, false);
    			lastImportedBooks=0;
    			lastBookImported=null;
			}else{
				if(currentScreen=="homelist")
					loadBooksOnList();
				if(currentScreen=="home")
					bb.pushScreen('home.html', 'home');
				//doAfterImportFromLibrary();
			}
		});
	}
}
function onComplete(){
	lastBookImported=ep.identifier;
	completedBooks++;
	doImportAll();
}
function onExistingBook(){
	doImportAll();
}
function onError(error){
	console.log(error);
	console.log("ERROR");
	if(filesToImport.length>=importPunt){
		var file=filesToImport[importPunt-1].split("/");
		importErrors.push(file[file.length-1]);
	}
	doImportAll();
}
function onProgress(status, current, total){
	if(!importSilent){
		if(status=="HUFF"){
			Toast.regular($.localize.data['app'].bookcompressed, 3000);
		}else{
			//console.log("Onprogress "+current+"/"+total+" "+status);
			//$('#loading').show();
			//$('#percentage p').html(Math.ceil(current*100/total)+"%");
			$('#loadingtext0 p').html($.localize.data['app'].importingfile+" "+(importPunt)+" "+$.localize.data['app'].of+" "+filesToImport.length);
			$('#loadingtext1 p').html(status);
			document.getElementById('progress').setValue((current*100/total));
		}
	}
}
function cancelBookImport(){
	if(work!=undefined){
		stopWorker();
	}
	if(ep!=undefined){
		ep.cancel();
		ep=undefined;
	}
	finishimport();
}



var work;
function startMobiWorker(file) {
    if(typeof(Worker) !== "undefined") {
        if(typeof(w) == "undefined") {
        	work = new Worker("js/formats/MobiWorker.js");
        }
        work.addEventListener('message', function(e) {
        	  if(e.data.action){
        		  switch(e.data.action){
        		  case "onComplete":onComplete();break;
        		  case "onSetIdentifier":
        			  ep.identifier=e.data.object;
        			  break;
        		  case "onExistingBook":onExistingBook();break;
        		  case "onError":onError(e.data);break;
        		  case "doSaveBook":
        			  //el worker no tiene aceso a localStorage
        			  var temp=JSON.parse(e.data.object);
        			  console.log("BOOK: ", temp);
        			  var book=new Book();
        			  for(var p in temp){
        				  book[p]=temp[p];
        			  }
        			  console.log("BOOK: ", book);

        			  book.saveBook();
        			  break;
        		  case "onProgress":onProgress(e.data.status, e.data.current, e.data.total);break;
        		  }
        	  }else{
        		  console.log(new Date().toLocaleString()+' Mobi Worker said: ', e);        		  
        	  }
        	}, false);
        work.addEventListener("error", function (evt) {
            console.log("Mobi Worker Line #" + evt.lineno + " - " + evt.message + " in " + evt.filename);
          }, false);
        
        work.postMessage({action: "extract", file: file, home: blackberry.io.home});
    } else {
       console.log("Worker not suported");
    }
}
function stopWorker(){
	work.terminate();
	work = undefined;
}
/*
var w;
function startFB2Worker(file) {
    if(typeof(Worker) !== "undefined") {
        if(typeof(w) == "undefined") {
            w = new Worker("js/formats/Fb2Worker.js");
        }
        w.addEventListener('message', function(e) {
        	  console.log('Worker said: ', e);
        	}, false);
        w.addEventListener("error", function (evt) {
            console.log("Line #" + evt.lineno + " - " + evt.message + " in " + evt.filename);
          }, false);
        
        w.postMessage({action: "extract", file: file, home: blackberry.io.home});
    } else {
       console.log("Worker not suported");
    }
}
function stopWorker() {
    w.terminate();
    w = undefined;
}
*/
