/*
 * Detalle de libro
 */
var epuburl="";
var mobiurl="";
var entry=null;
var bookthumb="";

function loadOPDSdetail(catalog){
	console.log(catalog);
	
	entry=catalog;
	$('#Spinner').show();
	bb.screens[bb.screens.length-2].params=null;
	document.getElementById('title').setCaption(catalog.title);
	var image=null;
	var thumb=null;
	
    _.each(catalog.links, function(link){
		console.log(link);
		
		if(link.type=="image/png" || link.type=="image/gif" || link.type=="image/jpg" || link.type=="image/jpeg"){
			if(link.rel=="http://opds-spec.org/image"){
				image=link.url;
			}
			if(link.rel=="http://opds-spec.org/image/thumbnail" || link.rel=="http://opds-spec.org/thumbnail"){
				thumb=link.url;
			}
		}
		if(link.type=="application/epub+zip"){
			epuburl=link.url;
		}
		if(link.type=="application/x-mobipocket-ebook"){
			mobiurl=link.url;
		}
    });
    $('#cover').load(function() {
    	$('#Spinner').hide();
    });
    $('#cover').error(function() {
    	$('#Spinner').hide();
    });
    
    if(thumb!=null)
    	bookthumb=thumb;
    else if(image!=null)
    	bookthumb=image;
    	
    
    if(image!=null)
    	$('#cover').attr("src", image);
    else if(thumb!=null)
    	$('#cover').attr("src", thumb);
    else{
    	$('#cover').hide();
    	$('#Spinner').hide();
    }
    $('#booktitle').html(catalog.title);
    if(catalog.author && catalog.author.name){
    	$('#bookauthor').html(catalog.author.name);
    }
    if(catalog.summary)
    	$('#description').html(catalog.summary.replace("\n", "<br/>"));
    else if(catalog.content)
    	$('#description').html(catalog.content.replace("\n", "<br/>") );
    if(catalog.rights && catalog.rights!=null && catalog.rights!=undefined){
    	$('#rightstext').html(catalog.rights );
    }else{
    	$('#rights').hide();
    }
    if(epuburl!=""){
    	document.getElementById('epubaction').show();
    }else{
    	document.getElementById('epubaction').hide();
    }
    if(mobiurl!=""){
    	document.getElementById('kindleaction').show();
    }else{
    	document.getElementById('kindleaction').hide();
    }
    /*
     * <dcterms:language>es</dcterms:language><dcterms:issued>1897</dcterms:issued><category term="FBFIC000000" scheme="http://www.feedbooks.com/categories" label="Ficción"/><category term="FBFIC027000" scheme="http://www.feedbooks.com/categories" label="Romance"/><category term="FBFIC027040" scheme="http://www.feedbooks.com/categories" label="Gótico"/><category term="FBFIC015000" scheme="http://www.feedbooks.com/categories" label="Horror"/>
     */
}


function downloadEpub(){
	if(epuburl!=""){
		addDownload("epub", entry.title, epuburl, bookthumb);
	}
}
function downloadKindle(){
	if(mobiurl!=""){
		addDownload("mobi", entry.title, mobiurl, bookthumb);
	}
}
