var book=new Book();
var actBarVisible=true;
var actBarTimer=null;
var selectionTimer=null;
var cloudSyncTimer=null;
var visibleWord=null;
var selectionPosition=null;
var bookLoaded=false;
var thereWasAnchorLoading=false;
var bookmarkLoading=null;
var withSwipeChapters=false;
var withpageflip=false;
var watchformat=false;
var withtouchkeyboard=false;
var withtouchscreen=true;
var wasGotoPercentage=false;
var gotoPercentageChapter=null;
var searchtext=new SearchText();
var searchPunt=-1;
var searchObject;
var wasSearching=false;



function doWatch(){
	//watchformat==true 24H
	var d;
	if(watchformat){
		var minutes=new Date().getMinutes();
		if(minutes < 10) {
			minutes = "0" + minutes;
		}
		d=new Date().getHours()+":"+minutes;
	}else{
		d=format_time(new Date());
	}
	$('#watch').html(d);
}
function format_time(date_obj) {
	// formats a javascript Date object into a 12h AM/PM time string
	var hour = date_obj.getHours();
	var minute = date_obj.getMinutes();
	var amPM = (hour > 11) ? "PM" : "AM";
	if(hour > 12) {
		hour -= 12;
	} else if(hour == 0) {
		hour = "12";
	}
	if(minute < 10) {
		minute = "0" + minute;
	}
	return hour + ":" + minute + amPM;
	}
function loadBook(params){
	lastBook=null;
	$('#swipemenu').offset({left: 0, top: -$('#swipemenu').height()-100});
	$('#Spinner').show();

	$('div').filter(function() {
	    if($(this).css('-webkit-overflow-scrolling') == '-blackberry-touch'){
	    	$(this).css('-webkit-overflow-scrolling', 'touch');
	    }
	});
	$('#swipemenu').appendTo("body");
	$('#flipbook').appendTo("body");
	$('#voicecontrols').appendTo("body");
	$('#Spinner').appendTo("body");

	$('#bodi').parent().parent().css("z-index", "-10");
    var bright=localStorage.getItem("brightness");
    if(!bright)
    	bright=100;
    setBrightness(bright);

	localStorage.setItem("lastBook", params.bookid);
	if(!book.loadBook(params.bookid)){
		$('#Spinner').hide();
        blackberry.ui.dialog.standardAskAsync("The book could not be loaded.", blackberry.ui.dialog.D_OK, function(){
        	bb.popScreen();
        }, {title : $.localize.data['app'].error});
		return;
	}
	book.lastdate=new Date().getTime();
	book.saveBook();
	for(var i=0; i<booklist.length; i++){
		if(booklist[i].identifier==book.identifier){
			booklist[i].lastdate=book.lastdate;
			if(sortBooksField=="lastdate")
				sortBooks();
			break;
		}
	}


	var title=book.title;
	if(book.autor!="")
		title+=" ("+book.autor+")";
	$('#booktitle').html(title);

	initCloudSync();

	var src=book.getCurrentChapterSrc();
	$('#bodi').css("visibility", "hidden");
	var arch=book.getUrl(src);
	var ancho=window.innerWidth;
	var alto=window.innerHeight-70-75;//menos las barras de arriba y abajo

	var margin=Math.floor((ancho-(88*8))/9)-2;
	$(".tdcontextbar").each(function(){
		$(this).css("padding-left", margin+"px");
	});

	$("<style type='text/css' id='mycss'> .mybook{border: 0;  width: "+(ancho-20)+"px; height:"+alto+"px !important; } </style>").appendTo("head");
	$('#bodi').addClass("mybook");
	var iframe=document.getElementById("bodi");
	iframe.onload = function(e) {
		var $body = $("#bodi").contents().find("body");
		$body.attr('id', "bodi");
	    var $head = $("#bodi").contents().find("head");
	    $head.find('meta[name=viewport]').remove();

	    $("#bodi").contents().find("body").find('a').each(function(i) {
	       var src=$(this).attr("href");
	       if(src){
		       console.log("replacing link "+src);
		       $(this).attr("href", "#");
		       $(this).attr("source", src);
	       }
	    });

	    var doc = document.getElementById("bodi").contentDocument;
	    doc.addEventListener("selectionchange", selectionChange, false);
	    doc.addEventListener("touchstart", touchStart, false);
	    doc.addEventListener("touchend", touchEnd, false);

	    $head.append($("<style type='text/css' id='mycss'> body{width: auto !important;overflow: hidden; line-height: 1.3em !important;text-align:justify !important;font-size: 2em !important;text-indent: 1em !important;border:0 !important;border: 0 !important; margin: 0 !important; padding: 0 !important; -webkit-column-width:"+(ancho-20)+"px !important; -webkit-column-gap:0px !important; height:"+alto+"px !important;} .day{background-image:none !important;color:#000000 !important;}a.day{color:#0000FF !important;text-decoration: underline !important;}.night{background-image:none !important;color:#ffffff !important;}a.night{color:#0000FF !important;text-decoration: underline !important;background-color:transparent !important;}.sepia{background-image:none !important;background-color:transparent !important;color:#614200 !important;}a.sepia{color:#0000FF !important;text-decoration: underline !important;background-color:transparent !important;}.currentpos{background-color:transparent !important;background-color:#000000 !important;color:#FFFFFF !important;}.searchtext{background-color: #000000 !important;color: #FFFFFF !important;}.searchtextnight{background-color: #FFFFFF !important;color: #000000 !important;}div,p,span{font-size: 1em !important;}h1{font-size: 1.4em !important;}h2{font-size: 1.3em !important;}h3{font-size: 1.2em !important;}h4,h5,h6,h7{font-size: 1.1em !important;}</style>"));
		$head.append($('<meta name="viewport" content="initial-scale=1, maximum-scale=1"/>'));

	    //aqui cargar fuente, spacing, margin, bright, theme
	    var bright=localStorage.getItem("brightness");
	    if(!bright)
	    	bright=100;
	    //setBrightness(bright);
	    document.getElementById("bright").setValue(bright);

	    var fontfamily=localStorage.getItem("fontfamily");
	    if(!fontfamily)
	    	fontfamily="Georgia";
	    changeFontFamily(fontfamily, false);
	    document.getElementById('fontfamily').setSelectedText(fontfamily);

	    var linespacing=localStorage.getItem("linespacing");
	    if(!linespacing)
	    	linespacing=15;
	    setLineSpacing(linespacing, false);
	    document.getElementById("linespacing").setValue(linespacing);

	    var indent=localStorage.getItem("indent");
	    if(!indent)
	    	indent=0;
	    setIndent(indent, false);
	    document.getElementById("marginlateral").setValue(indent);

	    var fontsize=localStorage.getItem("fontsize");
	    if(!fontsize)
	    	fontsize=15;
	    setFontSize(fontsize, false);
	    document.getElementById("fontsize").setValue(parseInt(parseFloat(fontsize)*10));

	    var theme=localStorage.getItem("theme");
	    document.getElementById('theme').setSelectedItem(theme);
	    setTheme();

	    var browsin=localStorage.getItem("showbrowsing");
	    if(browsin==null)
	    	browsin="true";
	    document.getElementById("showbrowsing").setChecked((browsin == "true"));
	    showNotesFavoritesHighlighted();

	    if(anchor!=""){
	    	console.log("anchor");
	    	console.log("ANCHOR :"+anchor);
	    	gotoAnchor(anchor);
	    	anchor="";
	    }else if(wasSearching){
	    	console.log("wasSearching");
	    	search(searchObject.searchtext, searchObject.index);
	    }else if(wasGotoPercentage){
	    	console.log("wasGotoPercentage");
	    	var page=book.getPageFromPercentage(gotoPercentageChapter, book.currentNPages);
	    	gotoPercentageChapter=null;
	    	wasGotoPercentage=false;
	    	showPage(page);
	    }else if(bookmarkLoading!=null){
	    	console.log("bookmarkLoading");
	    	showPage(bookmarkLoading.currentPage);
	    }else if(book.currentPosition!=null){
			gotoPagePosition(book.currentPosition);
			book.currentPosition=null;
	    }else{
	    	console.log("book.currentPage: "+book.currentPage);
	    	showPage(book.currentPage);
	    }
	};

	/*
	if(readingIframe!=null){
		console.log(readingIframe);
		$("#bodi").contents(readingIframe);
		$('#Spinner').hide();
		$('#bodi').css("visibility", "visible");
		//var el = document.getElementById('bodi');
		//el.parentNode.replaceChild(readingIframe, el);
		iframe=document.getElementById("bodi");
		readingIframe=null;
	}else{
	*/
	carga(arch);
	//}
	configureSettings();
	document.getElementById("swipemenu").addEventListener("touchend", function(e){
		e.stopPropagation();
		//e.preventDefault();
	}, false);
	document.getElementById("percentagebar").addEventListener("touchstart", function(e){
		if(actBarTimer!=null)
			clearInterval(actBarTimer);
	});
	document.getElementById("percentagebar").addEventListener("touchend", function(e){
		e.stopPropagation();
		//e.preventDefault();
		hideActionBar();
		var newpos=parseInt($('#percentage').val());
		if(newpos==100){
			gotoEnd();
		}else if(newpos==0){
			gotoStart();
		}else{
			var c=book.getChapterFromPercentage(newpos);
			var pointer=book.getPointertoChapter(c);
			gotoPercentageChapter={};
			gotoPercentageChapter.chapter=c;
			gotoPercentageChapter.per=newpos;

			if(pointer==book.currentPointer){
		    	var page=book.getPageFromPercentage(gotoPercentageChapter, book.currentNPages);
		    	gotoPercentageChapter=null;
		    	wasGotoPercentage=false;
		    	showPage(page);
			}else{
				wasGotoPercentage=true;
				var t=book.getUrl(c);
				carga(t);
			}
		}

	}, false);
	document.addEventListener("touchstart", touchStart, false);
	document.addEventListener("touchend", touchEnd, false);
	//document.addEventListener('keypress', onKeyPress);
	document.addEventListener('unhandledkeyinput', onKeyPress);
	document.addEventListener('menubutton', onMenuButton);
	document.addEventListener('backbutton', onBackButton);
	document.addEventListener("touchenabledkeyboard", touchKeyboardCallback);
	document.addEventListener("keyboardOpening", onKeyboardOpened);
	document.addEventListener("keyboardOpened", onKeyboardOpened);
	document.addEventListener("keyboardClosed", onKeyboardClosed);
	document.addEventListener("keyboardClosing", onKeyboardClosed);

	//document.addEventListener("volumedownbutton", prevPage, false);
	//document.addEventListener("volumeupbutton", nextPage, false);

	readerEvents.push({name: "touchstart", callback: touchStart});
	readerEvents.push({name: "touchend", callback: touchEnd});
	//readerEvents.push({name: "volumedownbutton", callback: prevPage});
	//readerEvents.push({name: "volumeupbutton", callback: nextPage});
	readerEvents.push({name: "unhandledkeyinput", callback: onKeyPress});
	readerEvents.push({name: "menubutton", callback: onMenuButton});
	readerEvents.push({name: "backbutton", callback: onBackButton});
	readerEvents.push({name: "swipedown", callback: showSwipeDownMenu, type:"blackberry.event"});
	//readerEvents.push({name: "touchenabledkeyboard", callback: touchKeyboardCallback});
	blackberry.event.addEventListener("swipedown", showSwipeDownMenu);

	$(window).resize(resizeWindow);
	hideActionBar();

	$('#linespacing').parent().find('.bb-slider-outer-light').bind( "touchend", function() {
		console.log("END OF LINE SPACING TOUCH");
		console.log($('#linespacing').val());
		$('#Spinner').show();
		setTimeout(function(){
			setLineSpacing($('#linespacing').val(), true);
		}, 500);
	});
	$('#fontsize').parent().find('.bb-slider-outer-light').bind( "touchend", function() {
		console.log("END OF font size");
		console.log($('#fontsize').val());
		$('#Spinner').show();
		setTimeout(function(){
			var val=$('#fontsize').val();
			val=val/10;
			console.log("NEW FONT: "+val);
			setFontSize(val, true);
		}, 500);
	});
	$('#marginlateral').parent().find('.bb-slider-outer-light').bind( "touchend", function() {
		console.log("END OF margin size");
		console.log($('#marginlateral').val());
		$('#Spinner').show();
		setTimeout(function(){
			setIndent($('#marginlateral').val(), true);
		}, 500);
	});
	setBookCover();
	$('#previmage').click(searchPrevious);
	$('#nextimage').click(searchNext);

	$("#flipbook").turn({
	    width: window.innerWidth,
	    height: window.innerHeight,
	    display: "single",
	    autoCenter: true,
	    turnCorners: "bl,br",
	    duration: 900,
	    elevation: 200
	});
	initVoiceControls();
}
function onKeyboardOpened(){
	console.log("onKeyboardOpened");
	document.getElementById('actbar').hide();
}
function onKeyboardClosed(){
	console.log("onKeyboardClosed");
	document.getElementById('actbar').hide();
}
function carga(arch){
	$('#Spinner').show();
	$('#bodi').css("visibility", "hidden");
	visibleWord=null;
	var pos=arch.indexOf("#");
	if(pos>0){
		anchor=arch.substring(pos, arch.length);
		arch = arch.substring(0, pos);
	}
	$("#bodi").attr("src", arch);
}
function selectionChange(e){
	if(selectionTimer!=null)
		clearInterval(selectionTimer);
	selectionTimer=setTimeout(doSelection, 500);
}
function doSelection(){
	console.log("doSelection");
	selectionTimer=null;
	var doc = document.getElementById("bodi").contentDocument;
	var sel = doc.getSelection();
	console.log(sel);
	var selection=sel.toString();

	if(selection.trim().length>0){
		var r=sel.getRangeAt(0);
	console.log(r);
		selectionPosition={};
		console.log(r.startContainer.parentNode);
		selectionPosition.startContainer=createXPathFromElement(r.startContainer.parentNode);
		selectionPosition.endContainer=createXPathFromElement(r.endContainer.parentNode);
		selectionPosition.startOffset=r.startOffset;
		selectionPosition.endOffset=r.endOffset;
		selectionPosition.startchild= getChildIndex(r.startContainer);
		selectionPosition.endchild=getChildIndex(r.endContainer);

		if(findActiveHighlight()){
			document.getElementById('addhighlightbutton').setImage('assets/white/highlight32del.png');
		}else{
			document.getElementById('addhighlightbutton').setImage('assets/white/highlight32.png');
		}
		if(findActiveBookmark()){
			document.getElementById('addbookmarkbutton').setImage('assets/white/bookmark32del.png');
		}else{
			document.getElementById('addbookmarkbutton').setImage('assets/white/bookmark32add.png');
		}
		$('#contextbar').show();
	}else
		$('#contextbar').hide();
}
function showSwipeDownMenu(){
	if(actBarVisible){
		document.getElementById('actbar').hide();
		$('#percentagebar').hide();
		if(actBarTimer!=null)
			clearInterval(actBarTimer);
		actBarVisible=false;
		actBarTimer=null;
	}
	$('#swipemenu').css("visibility", "visible");
	var alto=$('#swipemenu').height();
	var fin=0;

    if($('#swipemenu').position().top==0){
    	fin=-alto-50;
    }
    $('#swipemenu').animate({
        top: fin
       }, 400, "swing", function(){
    	   if(fin<0){
    		   $('#swipemenu').css("visibility", "visible");
   				takeScreenshot();
    	   }
       });
}
function resizeWindow(){
	if($('#searchbar').css("display")=='none'){
		$('#Spinner').show();
		$("#mycss").remove();
		var ancho=window.innerWidth;
		var alto=window.innerHeight-70-75;//menos las barras de arriba y abajo
		$("<style type='text/css' id='mycss'> .mybook{border: 0;  width: "+(ancho-20)+"px; height:"+alto+"px !important; } </style>").appendTo("head");
		$('#bodi').addClass("mybook");
		$("#bodi").contents().find("#mycss").remove();
	    var $head = $("#bodi").contents().find("head");
	    $head.append($("<style type='text/css' id='mycss'> body{width: auto !important; overflow: hidden; line-height: "+(localStorage.getItem("linespacing")/10)+"em !important;text-align:justify !important;font-size: "+(localStorage.getItem("fontsize")/10)+"em !important;text-indent: "+localStorage.getItem("indent")+"px !important;border:0 !important;border: 0 !important; margin: 0 !important; padding: 0 !important; -webkit-column-width:"+(ancho-20)+"px !important; -webkit-column-gap:0px !important; height:"+alto+"px !important;} .day{background-image:none !important;color:#000000 !important;}a.day{color:#0000FF !important;text-decoration: underline !important;}.night{background-image:none !important;color:#ffffff !important;}a.night{color:#0000FF !important;text-decoration: underline !important;background-color:transparent !important;}.sepia{background-image:none !important;background-color:transparent !important;color:#614200 !important;}a.sepia{color:#0000FF !important;text-decoration: underline !important;background-color:transparent !important;}.currentpos{background-color:transparent !important;background-color:#000000 !important;color:#FFFFFF !important;}.searchtext{background-color: #000000 !important;color: #FFFFFF !important;}.searchtextnight{background-color: #FFFFFF !important;color: #000000 !important;}div,p,span{font-size: 1em !important;}h1{font-size: 1.4em !important;}h2{font-size: 1.3em !important;}h3{font-size: 1.2em !important;}h4,h5,h6,h7{font-size: 1.1em !important;}</style>"));
	    showPage(book.currentPage);
		var margin=Math.floor((ancho-(80*8))/9)-1;
		$(".tdcontextbar").each( function() {
			$(this).css("padding-left", margin+"px");
		});
	}else{
		document.getElementById('actbar').hide();
		console.log("resize due to keyboard");
	}
	$("#flipbook").turn("destroy");
	$("#flipbook").empty();
	$("#flipbook").append('<div style="background-color: transparent;" id="pn1"><img id="myimage" /></div>');
	$("#flipbook").append('<div style="background-color: transparent;" id="pn2"></div>');

	$("#flipbook").turn({
	    width: window.innerWidth,
	    height: window.innerHeight,
	    display: "single",
	    autoCenter: true,
	    turnCorners: "bl,br",
	    duration: 900,
	    elevation: 200
	});

	$('#voiceicon').css("top", (window.innerHeight-$('#voiceicon').height())/2+"px");
	$('#voiceicon').css("left", (window.innerWidth-$('#voiceicon').width())/2+"px");

	takeScreenshot();
}

function setWidth(){
	console.log("SET WIDTH: "+book.currentPage);
	var bodi = $("#bodi").contents().find("body");
	  var desiredWidth=window.innerWidth-20;
	  var totalwidth=bodi[0].scrollWidth;
	  book.currentNPages=Math.ceil(totalwidth/desiredWidth);

console.log("setWidth", book.history);
	  console.log("book.currentNPages: "+book.currentNPages);
	  var percent=book.getPercentage();
	  $('#currentPage').html((book.currentPage+1)+"/"+book.currentNPages);
	  $('#percentagePage').html(percent+"%");
	  $('#percentageFill').width(percent+"%");

	  var w=$('#percetagebar').width();
	  var perc=book.getPercentageEndChapter();

	  $("#chapterEnd").css('left', (perc*w/100)+"px");
	  var alto=window.innerHeight-75;//menos las barras de abajo
	  $('#progressarea').css('top', alto+"px");
	}

function hideActionBar(){
	console.log("hideActionBar");
	if(actBarTimer!=null)
		clearInterval(actBarTimer);
	actBarTimer=setTimeout(function(){
		try{
			document.getElementById('actbar').hide();
		}catch(e){
			console.log("HIDE ACTION BAR FAULT");
		}
		$('#percentagebar').hide();
		actBarVisible=false;
		actBarTimer=null;
	}, 5000);
}
var startPosX=0;
var startPosY=0;
var isOnLongPress=false;
var iszoom=false;
var zoominit=0;
var zoomend1=null;

function touchStart(e){
	console.log(e);
	iszoom=false;
	if(e.touches.length==2){
		iszoom=true;
		zoominit =Math.sqrt((e.touches[0].screenX-e.touches[1].screenX) * (e.touches[0].screenX-e.touches[1].screenX) + (e.touches[0].screenY-e.touches[1].screenY) * (e.touches[0].screenY-e.touches[1].screenY));
	}
	  var touchobj = e.changedTouches[0];
	  startPosX = parseInt(touchobj.clientX);
	  startPosY = parseInt(touchobj.clientY);
}
function touchEnd(e){
	console.log(e);
	var touchobj = e.changedTouches[0];
	var doc = document.getElementById("bodi").contentDocument;
	var selection=doc.getSelection().toString();
	if(selection.trim().length>0)
		return;

	if(iszoom==true){
		if(e.touches.length>0){//espero a que no queden dedos
			zoomend1=e.changedTouches[0];
			return;
		}
		console.log("ZOOM FIN")
		var zoomfin =Math.sqrt((zoomend1.screenX-e.changedTouches[0].screenX) * (zoomend1.screenX-e.changedTouches[0].screenX) + (zoomend1.screenY-e.changedTouches[0].screenY) * (zoomend1.screenY-e.changedTouches[0].screenY));
		console.log(zoominit, zoomfin);
		var avance=zoomfin-zoominit;
		var avanceabs=Math.abs(avance);
		var steps=avanceabs/10;
		var fontsize=parseInt(localStorage.getItem("fontsize"))*10;
		console.log("OLD FONT: "+fontsize);
		if(avance>0){
			fontsize=fontsize+steps;
			if(fontsize>400)
				fontsize=400;
		}else{
			fontsize=fontsize-steps;
			if(fontsize<130)
				fontsize=130;
		}
		fontsize=fontsize/10;
		console.log("NEW FONT: "+fontsize);
		setFontSize(fontsize, true);
		document.getElementById("fontsize").setValue(parseInt(parseFloat(fontsize)*10));
		iszoom=false;
		return;
	}

	var isLink=checkIsLink(touchobj.clientX, touchobj.clientY);
	console.log("isLink: "+isLink);
	if(isLink!=null && isLink!="image" && isLink!="audio" && isLink!="zoom"){
		console.log("Link: "+isLink);
		e.stopPropagation();
		e.preventDefault();

		if(isLink.indexOf("http://")==0 || isLink.indexOf("https:/")==0){
		    blackberry.invoke.invoke({
		    	target: "sys.browser",
		        uri: isLink
		    }, function(){}, function(){});
		}else{
			if(isLink.substr(0, 1)=="#"){
				gotoAnchor(isLink.substr(1));
			}else{
				var pt=book.getPointertoChapter(isLink);
				if(pt!=-1){
					if(isLink.indexOf("#")>0)
						thereWasAnchorLoading=true;
					book.currentPage=0;
					var arch=book.getUrl(isLink);
					carga(arch);
				}else{
					Toast.regular($.localize.data['app'].errorloadinglink, 3000);
				}
			}
		}
		return;
	}
	if(isLink=="image" || isLink=="audio" || isLink=="zoom"){
		e.stopPropagation();
		e.preventDefault();
		return;
	}


  console.log(touchobj);
  var xdiff=touchobj.clientX-startPosX;
  //xdiff>100=>swipe right
  //xdiff< -100=>swipe right

  //si quiero cerrar el overlay del menu

  var el=$(e.target);
  if(el.hasClass('bb-context-menu-item') || el.hasClass('bb-context-menu-item-inner') || el.hasClass('bb-context-menu-overlay') ||  el.hasClass('bb-context-menu-item-image')){
		//e.stopPropagation();
		//e.preventDefault();
		return;//si es un item del menu
  }

  //swipe menu
  if($('#swipemenu').css('visibility')!="hidden" && $('#swipemenu').position().top==0){
		e.stopPropagation();
		e.preventDefault();

		var alto=$('#swipemenu').height()+50;
		console.log(alto);
	    $('#swipemenu').animate({
	        top: -alto
	       }, 400, "swing", function(){
    		   $('#swipemenu').css("visibility", "visible");
    		   takeScreenshot();
	       });
	  return;
  }
  if(actBarVisible && parseInt(touchobj.clientY)>(window.innerHeight-120)){
		//e.stopPropagation();
		//e.preventDefault();
		actBarVisible=true;
		hideActionBar();
		return;
  }
  if(actBarVisible || actBarTimer!=null){
		e.stopPropagation();
		e.preventDefault();
		//actbar visible y con timer para ocultarla
		console.log("1");
		if(actBarTimer!=null)
			clearInterval(actBarTimer);
		document.getElementById('actbar').hide();
		$('#percentagebar').hide();
		actBarVisible=false;
		actBarTimer=null;
  }else if(parseInt(touchobj.clientY)<150 || parseInt(touchobj.clientY)>(window.innerHeight-75)){
		e.stopPropagation();
		e.preventDefault();

		console.log("2");
	  	document.getElementById('actbar').show();
	  	showPercentageSlider();
	  	actBarVisible=true;
	  	hideActionBar();
  }else if(withSwipeChapters && xdiff>100){//swipe right
		e.stopPropagation();
		e.preventDefault();
		if(withtouchscreen){
			nextChapter();
		}
  }else if(withSwipeChapters && xdiff < -100){//swipe left
		e.stopPropagation();
		e.preventDefault();
		//var t=book.getPrevChapter();
		if(withtouchscreen){
			if(book.currentPointer>0){
			//if(t!=""){
				prevChapter(true);
			}
		}
  }else if(!withSwipeChapters && xdiff>100){//swipe right
		e.stopPropagation();
		e.preventDefault();
		if(withtouchscreen){
			prevPage();
		}
  }else if(!withSwipeChapters && xdiff < -100){//swipe left
		e.stopPropagation();
		e.preventDefault();
		if(withtouchscreen){
			nextPage();
		}
  }else if(parseInt(touchobj.clientX)>=(window.innerWidth/2)){
		e.stopPropagation();
		e.preventDefault();
		if(withtouchscreen){
			nextPage();
		}
  }else if(parseInt(touchobj.clientX)<(window.innerWidth/2)){
		e.stopPropagation();
		e.preventDefault();
		if(withtouchscreen){
			prevPage();
		}
  }
  console.log("DIFF: "+(startPosX-parseInt(touchobj.clientX)));
}

var takeSnapshotStatus=0;
var snapshotTimer=null;
var wasNext=false;
var wasPrev=false;
var nextAction=[];
function takeScreenshot(){
	if(withpageflip){
		if(actBarVisible){
			setTimeout(function(){
				takeScreenshot();
			}, 1000);
		}else{
			if(snapshotTimer!=null)
				clearInterval(snapshotTimer);
			snapshotTimer=setTimeout(function(){
				takeSnapshotStatus=1;
				var a=new Date().getTime();
				console.log("CAPTURING", a);
			    var options = {dest:'data:', quality: 20};//, mime:'image/png'};//, rect: {x: 0, y: 70, w: window.innerWidth, h: alto}};
			    blackberry.screenshot.execute(options, function(screenshot){
			    	console.log("CAPTURE DONE ", new Date().getTime(), a-new Date().getTime());
			        $('#myimage').attr('src', screenshot).load(function() {
			        	console.log("LOADED n");
			        	$('#myimage').unbind('load');
				        takeSnapshotStatus=2;


				        console.log("nextAction: "+nextAction);
				        if(nextAction.length>0){
				        	var act=nextAction.shift();
				        	console.log("nextAction "+act.action);
				        	switch(act.action){
				        	case "next":
				        		nextPage();
				        		break;
				        	case "nextchapter":
				        		nextChapter();
				        		break;
				        	case "prev":
				        		prevPage();
				        		break;
				        	case "prevchapter":
				        		prevChapter(act.tobegin);
				        		break;
				        	}
				        }
			        });
			    }, function(err){
			    	console.log("ERROR TAKING SCREENSHOT");
			    	console.log(err);
			    });
			    snapshotTimer=null;
			}, 100);
		}
	}
}

function hideFlipBook(event, page, view){
	  $("#flipbook").css("z-index", -1);
	  $('#flipbook').unbind('turned');
	  console.log("DISABLE FLIPBOOK");
	  visibleWord=findVisibleWord();
	  console.log("visibleWord", visibleWord);

	  takeScreenshot();
}
function nextPage(){
	console.log("NEXT PAGE");
	if(book.currentPage<(book.currentNPages-1)){
		if(withpageflip){
			console.log("IS ANIMATING: "+$("#flipbook").turn("animating"));
			if ($("#flipbook").turn("animating")) {
				nextAction.push({action: "next", tobegin: false});
				return;
			}
			$("#flipbook").turn("page", 1).turn('stop');
			$('#myimage').appendTo("#pn1");
			$("#flipbook").bind("turned", hideFlipBook);
	    	$("#flipbook").css("z-index", 500);
	    	wasNext=true;
	    	showPage(book.currentPage+1);
		}else{
			showPage(book.currentPage+1);
		}
	}else{
		nextChapter();
	}
}
function nextChapter(){
	var t=book.getNetxChapter();
	console.log("nextChapter cuurentpage "+book.currentPage);
	if(t!=""){
		if(withpageflip){
			if ($("#flipbook").turn("animating")) {
				nextAction.push({action: "nextchapter", tobegin: false});
				return;
			}
			$("#flipbook").turn("page", 1).turn('stop');
			$('#myimage').appendTo("#pn1");
			$("#flipbook").bind("turned", hideFlipBook);
	    	$("#flipbook").css("z-index", 500);
	    	wasNext=true;
	    	carga(t);
		}else{
			carga(t);
		}
	}
}

function prevPage(){
	if(book.currentPage>0){
		if(withpageflip){//} && takeSnapshotStatus==2){
			if ($("#flipbook").turn("animating")) {
				nextAction.push({action: "prev", tobegin: false});
				return;
			}
			$("#flipbook").turn("page", 2).turn('stop');
			$('#myimage').appendTo("#pn2");
			$("#flipbook").bind("turned", hideFlipBook);
	    	$("#flipbook").css("z-index", 500);
	    	wasPrev=true;
	    	showPage(book.currentPage-1);
		}else{
			showPage(book.currentPage-1);
		}
	}else{
		prevChapter(false);
	}
}
function prevChapter(tobegin){
	var t=book.getPrevChapter();
	if(tobegin)
		book.currentPage=0;

	if(t!=""){
		if(withpageflip){
			if ($("#flipbook").turn("animating")) {
				nextAction.push({action: "prevchapter", tobegin: tobegin});
				return;
			}
			$("#flipbook").turn("page", 2).turn('stop');
			$('#myimage').appendTo("#pn2");
			$("#flipbook").bind("turned", hideFlipBook);
	    	$("#flipbook").css("z-index", 500);
	    	wasPrev=true;
	    	carga(t);
		}else{
			carga(t);
		}
	}
}
function showPage(npage){
	bookmarkLoading=null;
	console.log("showPage: "+npage);
	var bodi = $("#bodi").contents().find("body");

	setWidth();
    if(npage<=(book.currentNPages-1)){
		book.setCurrentPage(npage);
		bodi.scrollLeft(bodi.outerWidth()*npage);
	}else{
		//si no existe la pagina pongo la ultima
		book.setCurrentPage(book.currentNPages-1);
		bodi.scrollLeft(bodi.outerWidth()*book.currentPage);
	}
	var percent=book.getPercentage();
	$('#currentPage').html((book.currentPage+1)+"/"+book.currentNPages);
	$('#percentagePage').html(percent+"%");
	$('#percentageFill').width(percent+"%");
	var w=$('#percetagebar').width();
	var perc=book.getPercentageEndChapter();
	$("#chapterEnd").css('left', (perc*w/100)+"px");
	var alto=window.innerHeight-75;//menos las barras de abajo
	$('#progressarea').css('top', alto+"px");

    //setWidth();
	$('#bodi').css("visibility", "visible");
	visibleWord=findVisibleWord();
	console.log("visibleWord", visibleWord);
	$('#Spinner').hide();

	/*
	 * cambio de capitulo con pageflip*/
	takeSnapshotStatus=0;
	console.log("wasNext: "+wasNext);
	console.log("wasPrev: "+wasPrev);
	if(wasNext){
		$("#flipbook").turn("next");
	}else if(wasPrev){
		console.log("GO PREVIOUS");
		$("#flipbook").turn("previous");
	}else{//esta para cuando se carga sin accion
		takeScreenshot();
	}
	wasNext=false;
	wasPrev=false;

	//was speeching
	if(voicestatus==1){
		speechPage();
	}
	//esto va en un timer para no encadenar N peticiones
	if(bookLoaded){// && visibleWord!=null
		if(cloudSyncTimer!=null)
			clearInterval(cloudSyncTimer);
		cloudSyncTimer=setTimeout(function(){
			var js=JSON.stringify(visibleWord);
			console.log("updating cloud", visibleWord);
			//registro que este se ha actualizado
			book.lastsynced=book.lastsynced+1;
			book.saveBook();
			cloudsync.saveBookPosition(book, js);
			cloudSyncTimer=null;
		}, 5000);
	}
}



/*
 * Style functions
 *
 */

function changeFontFamily(fuente, dowith){
    localStorage.setItem("fontfamily", fuente);
	//$("#bodi").contents().find("body").css('font-family', fuente+"");
	//$("#bodi").contents().find("body").find('*').css('font-family', fuente+"");
	
    var $head = $("#bodi").contents().find("head");
    $("#bodi").contents().find("#myfontfamilycss").remove();
    $head.append($("<style type='text/css' id='myfontfamilycss'>*{font-family: "+fuente+" !important;}</style>"));
    
	console.log("changeFontFamily");
	if(dowith)
		setWidth();
	//showPage(actualPage);
}
function setFontFamily(){
	console.log("setFontFamily");
	$('#Spinner').show();
	changeFontFamily($('#fontfamily').val(), true);
	console.log("visibleWord", visibleWord);
	if(visibleWord!=null)
		gotoPagePosition(visibleWord);
	$('#Spinner').hide();
}
function setTheme(){
	console.log("setTheme");
	$('#Spinner').show();
	var state=parseInt($('#theme').val());
	var bodi=$("#bodi").contents().find("body");
	localStorage.setItem("theme", state);

    var $head = $("#bodi").contents().find("head");
    $("#bodi").contents().find("#mythemecss").remove();

    
	if(state==1){
	    $head.append($("<style type='text/css' id='mythemecss'>*{background-image:none !important;color:#ffffff !important;} a{color:#0000FF !important;text-decoration: underline !important;background-color:transparent !important;}</style>"));

		//bodi.find("*").removeClass("day sepia night").addClass("night");
		$('#readerscreen').css('background-color', "rgb(0, 0, 0)");
		$("#readerscreen").removeClass("day sepia night").addClass("night");
		$("#titlearea").find('*').removeClass("day sepia night").addClass("night");
		$("#progressarea").find('*').removeClass("day sepia night").addClass("night");
		$("#chapterEnd").css("background-color", "white");
		$("#percetagebar").css("border-color", "white");
		$("#percentageFill").css("background-color", "white");

		$( "<style>#flipbook .page {background-color : black}</style>" ).appendTo( "head" );
	}else if(state==0){
	    $head.append($("<style type='text/css' id='mythemecss'>*{background-image:none !important;color:#000000 !important;} a{color:#0000FF !important;text-decoration: underline !important;}"));

		//bodi.find("*").removeClass("day sepia night");
		$('#readerscreen').css('background-color', "rgb(255, 255, 255)");
		$("#readerscreen").removeClass("day sepia night").addClass("day");
		$("#titlearea").find('*').removeClass("day sepia night").addClass("day");
		$("#progressarea").find('*').removeClass("day sepia night").addClass("day");
		$("#chapterEnd").css("background-color", "black");
		$("#percetagebar").css("border-color", "black");
		$("#percentageFill").css("background-color", "black");
		$( "<style>#flipbook .page {background-color : white}</style>" ).appendTo( "head" );
	}else if(state==2){
	    $head.append($("<style type='text/css' id='mythemecss'>*{background-image:none !important;background-color:transparent !important;color:#614200 !important;} a{color:#0000FF !important;text-decoration: underline !important;background-color:transparent !important;}</style>"));

		$('#readerscreen').css('background-color', "rgb(230, 209, 166)");
		$("#readerscreen").removeClass("day sepia night").addClass("sepia");
		//bodi.find("*").removeClass("day sepia night").addClass("sepia");
		$("#titlearea").find('*').removeClass("day sepia night").addClass("sepia");
		$("#progressarea").find('*').removeClass("day sepia night").addClass("sepia");
		$("#chapterEnd").css("background-color", "#614200");
		$("#percetagebar").css("border-color", "#614200");
		$("#percentageFill").css("background-color", "#614200");
		$( "<style>#flipbook .page {background-color : rgb(230, 209, 166)}</style>" ).appendTo( "head" );

	}
	$('#Spinner').hide();
}
function setFontSize(val, dowith){
	console.log("setFontSize");
	localStorage.setItem("fontsize", val);
	if(window.innerWidth > 1400)
		val=val*2;
	val=val/10;

	$('#Spinner').show();
	$("#bodi").contents().find("#fontsizeclass").remove();
    $("#bodi").contents().find("head").append($("<style type='text/css' id='fontsizeclass'> body{font-size: "+val+"em !important;} </style>"));

	//$("#bodi").contents().find("body").css('font-size', val+"em");
	//$("#bodi").contents().find("body").find('*').css('font-size', val+"em");
    if(dowith)
    	setWidth();
	if(visibleWord!=null)
		gotoPagePosition(visibleWord);
	$('#Spinner').hide();
}
function setLineSpacing(val, dowith){
	console.log("setLineSpacing: "+val);
    localStorage.setItem("linespacing", val);

	$('#Spinner').show();
	val=val/10;
	console.log("line spacing: "+val);
	
    var $head = $("#bodi").contents().find("head");
    $("#bodi").contents().find("#mylinespacingcss").remove();
    $head.append($("<style type='text/css' id='mylinespacingcss'>*{line-height: "+val+"em !important;}</style>"));
    
	//$("#bodi").contents().find("body").find('*').css('line-height', val+"em");
	//$("#bodi").contents().find("body").find('*').css('line-height', val+"em !important");

	if(dowith)
		setWidth();
	if(visibleWord!=null)
		gotoPagePosition(visibleWord);
	$('#Spinner').hide();
}
function setIndent(val, dowith){
	console.log("setIndent");
    localStorage.setItem("indent", val);
	$('#Spinner').show();
	var varlo=val+"px";
	
	//$("#bodi").contents().find("body").find('*').css('margin-left', varlo);
	//$("#bodi").contents().find("body").find('*').css('margin-right', varlo);
	
    var $head = $("#bodi").contents().find("head");
    $("#bodi").contents().find("#mymargincss").remove();
    $head.append($("<style type='text/css' id='mymargincss'>body * {margin-left: "+varlo+" !important;margin-right: "+varlo+" !important;}</style>"));
    
	if(dowith)
		setWidth();
	if(visibleWord!=null)
		gotoPagePosition(visibleWord);
	$('#Spinner').hide();
}
function setBrightness(val){
	localStorage.setItem("brightness", val);
	$('#readerscreen').css('-webkit-filter', "brightness("+val+"%)");

	/*
	var state=localStorage.getItem("theme");

	if(state==1){
		$('#readerscreen').css('-webkit-filter', "invert(100%) sepia(0%) brightness("+val+"%)");
	}else if(state==0){
		$('#readerscreen').css('-webkit-filter', "invert(0%) sepia(0%) brightness("+val+"%)");
	}else if(state==2){
		$('#readerscreen').css('-webkit-filter', "invert(0%) sepia(100%) brightness("+val+"%)");
	}
	*/
	/*
	 * 		//	-webkit-filter: sepia(100%);
		-webkit-filter: brightness(15%);

	if(state==1){
		$('#readerscreen').css('background-color', "rgba(255, 255, 255,"+(val/10)+")");
	}else if(state==0){
		$('#readerscreen').css('background-color', "rgba(255, 255, 255,"+(val/10)+")");
	}else if(state==2){
		$('#readerscreen').css('background-color', "rgba(230, 209, 166,"+(val/10)+")");
	}
	*/
}

function setUseStyles(toggle){

}
function setBrowsingVisible(toggle){
	localStorage.setItem("showbrowsing", toggle.getChecked());
	if(toggle.getChecked()){
		$('#titlearea').css("visibility", "visible");
		$('#progressarea').css("visibility", "visible");
	}else{
		$('#titlearea').css("visibility", "hidden");
		$('#progressarea').css("visibility", "hidden");
	}
}
function gotoPagePosition(position){
	//return {"startContainer": startContainer, "endContainer": endContainer, "startOffset": startOffset, "endOffset": endOffset, "startchild": startchild, "endchild": endchild, "page": book.currentPage, id:""};
	var doc = document.getElementById("bodi").contentDocument;
	var desiredWidth=window.innerWidth-20;
	var bodi = $("#bodi").contents().find("body");
	//visibleWord
	try{
		if(position.id!=""){
			var elem=$("#bodi").contents().find("#"+position.id);
			var p=Math.floor(elem.offset().left/desiredWidth);
			showPage(p);
		}else{
			var o1=lookupElementByXPath(position.startContainer).childNodes[position.startchild];
			var o2=lookupElementByXPath(position.endContainer).childNodes[position.endchild];

			var range = doc.createRange();
			range.setStart(o1, position.startOffset);
			range.setEnd(o2, position.endOffset);

			if(position.id==""){//posiciones last point
				range.expand("word");
				var newNode = document.createElement("span");
				newNode.setAttribute('class', 'currentpos');
				newNode.className='currentpos';
				range.surroundContents(newNode);

				newNode.id="currentpos";
				newNode.setAttribute('id', 'currentpos');
				setTimeout(function(){
					unSetHighlight('currentpos');
				}, 5000);
			}

			var pos=range.getBoundingClientRect().left;
			var p=Math.floor((pos+bodi.scrollLeft())/desiredWidth);
			showPage(p);
		}
	}catch(err){
		console.log(err);
		showPage(position.page);
	}
}

function unSetHighlight(id){
	try{
		var elem=$("#bodi").contents().find("#"+id);
		elem.before(elem.html());
		elem.remove();

		for(var i=0; i<20; i++){
			elem=$("#bodi").contents().find("#"+id+"_"+i);
			elem.before(elem.html());
			elem.remove();
		}
	}catch(err){
		console.log(err);
	}
}

/*
TOC
*/
function loadToc(params){
	$('#Spinner').show();
	book.loadBook(params.bookid);
	var items=[];
	var indextoc=book.getTocIndexFromChapter();
	var selecteditem="";

	for(var i=0; i<book.toc.length; i++){
		var item = document.createElement('div');
		item.setAttribute('data-bb-type','item');
		item.setAttribute('data-bb-title', book.toc[i].label.replace(/ /g, "&nbsp;"));
		item.setAttribute('source', book.toc[i].src);
		item.onclick = gotoTocChapter;
		if(indextoc == i){
			item.setAttribute('style', "background-color: rgb(228, 228, 228)");
			item.setAttribute('id', "scrollselected");
		}
		items.push(item);
	}
	document.getElementById('toclist').refresh(items);
	var element = document.getElementById('scrollselected');
	document.getElementById('tocscreen').scrollToElement(element);

	$('#Spinner').hide();
}

function gotoTocChapter(){
	//si es distinto!
	var selected = document.getElementById('toclist').selected;
	var src=selected.getAttribute("source");
	var pos=src.indexOf("#");
	if(pos>=0){
		anchor=src.substring(pos);
		src=src.substring(0, pos);
		console.log("ANCHOR :"+anchor);
	}
	var pointer=book.getChapterFromSrc(src);
	console.log("go to toc: "+src);
	console.log("go to toc: "+pointer);
	book.currentPointer=pointer;
	book.currentPage=0;
	book.saveBook();
	//book.setCurrentPage(0);
	bb.popScreen();
}

/*
 * TEXT SELECTION
 */
function unSelect(){
	var doc = document.getElementById("bodi").contentDocument;
	var sel = doc.getSelection();
	sel.removeAllRanges();
	$('#contextbar').hide();
}

function getChildIndex(child){
	var parent = child.parentNode;
	var children = parent.childNodes;
	var count = children.length;
	var child_index=0;
	for (var i = 0; i < count; i++) {
	  if (child === children[i]) {
	    child_index = i;
	    break;
	  }
	}
	return child_index;
}

function createXPathFromElement(elm) {
	var doc = document.getElementById("bodi").contentDocument;
    var allNodes = doc.getElementsByTagName('*');
    for (var segs = []; elm && elm.nodeType == 1; elm = elm.parentNode){
        if (elm.hasAttribute('id')) {
                var uniqueIdCount = 0;
                for (var n=0;n < allNodes.length;n++) {
                    if (allNodes[n].hasAttribute('id') && allNodes[n].id == elm.id) uniqueIdCount++;
                    if (uniqueIdCount > 1) break;
                };
                if ( uniqueIdCount == 1) {
                    segs.unshift('id("' + elm.getAttribute('id') + '")');
                    return segs.join('/');
                } else {
                    segs.unshift(elm.localName.toLowerCase() + '[@id="' + elm.getAttribute('id') + '"]');
                }
        //} else if (elm.hasAttribute('class')) {
        //    segs.unshift(elm.localName.toLowerCase() + '[@class="' + elm.getAttribute('class') + '"]');
        } else {
            for (i = 1, sib = elm.previousSibling; sib; sib = sib.previousSibling) {
                if (sib.localName == elm.localName)  i++; };
                segs.unshift(elm.localName.toLowerCase() + '[' + i + ']');
        };
    };
    return segs.length ? '/' + segs.join('/') : null;
};

function nsResolver(prefix) {
	if (prefix === 'xhtml')
		return 'http://www.w3.org/1999/xhtml';
	else return null;
};
var donexhtml=false;
function lookupElementByXPath(path) {
    var evaluator = new XPathEvaluator();
    var result = evaluator.evaluate(path, document.getElementById("bodi").contentDocument, nsResolver, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
    if(result.singleNodeValue!=null){
    	donexhtml=false;
    	return  result.singleNodeValue;
    }else{
    	if(!donexhtml){
	    	var newpath=path.split("/");
	    	for(var i=0; i<newpath.length; i++){
	    		var str=newpath[i];
	    		if(str.indexOf("xhtml:")==0){
	    			return null;
	    		}
	    		if(str.indexOf("id(")==0){
	    			continue;
	    		}else{
	    			str="xhtml:"+str;
	    			newpath[i]=str;
	    		}
	    	}
	    	path=newpath.join("/");
	    	console.log("NEW PATH: "+path);
	    	donexhtml=true;
	    	return lookupElementByXPath(path);
    	}else{
    		donexhtml=false;
    		return null;
    	}
    }
}

function checkIsLink(cx, cy) {
	var doc = document.getElementById("bodi").contentDocument;
	try{
		var elem=doc.elementFromPoint(cx, cy);
		var $items = $(".jquery-image-zoom");
		if($items.length){
			$(".jquery-image-zoom").click();
			$("#bodi").css({ opacity: 1 });
			return "zoom";
		}

		if(elem.tagName.toLowerCase()=="img"){
			$(elem).unbind('click');
			$(elem).imageZoom();
			$(elem).click();
			$("#bodi").css({ opacity: 0.1 });
			return "image";
		}else if(elem.tagName=="AUDIO"){
			try{
				if(elem.paused)
					elem.play();
				else
					elem.pause();
			}catch(e){
			}
			return "audio";
		}else if(elem.tagName.toUpperCase()=="A"){
			return getLinksAtPointElem(elem);
		}else if(elem.parentNode.tagName.toUpperCase() =="A"){
			return getLinksAtPointElem(elem.parentNode);
		}else if(elem.parentNode.parentNode.tagName.toUpperCase()=="A"){
			return getLinksAtPointElem(elem.parentNode.parentNode);
		}else if(elem.parentNode.parentNode.parentNode.tagName.toUpperCase()=="A"){
			return getLinksAtPointElem(elem.parentNode.parentNode.parentNode);
		}else if(elem.parentNode.parentNode.parentNode.parentNode.tagName.toUpperCase()=="A"){
			return getLinksAtPointElem(elem.parentNode.parentNode.parentNode.parentNode);
		}else if(elem.parentNode.parentNode.parentNode.parentNode.parentNode.tagName.toUpperCase()=="A"){
			return getLinksAtPointElem(elem.parentNode.parentNode.parentNode.parentNode.parentNode);
		}else if(elem.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.tagName.toUpperCase()=="A"){
			return getLinksAtPointElem(elem.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode);
		}else{
			return null;
		}
	}catch(e){
		console.log(e);
		return null;
	}
}
function getLinksAtPointElem(elem) {
	var jelm = $(elem);
	var	exp=jelm.attr("source").split("/");
	var tem="";

	
	if(exp[0]=="http:" || exp[0]=="https:"){//is link
		tem=jelm.attr("source");
	}else if(jelm.attr("source").indexOf("#")==0){
		tem=jelm.attr("source");
	}else{
		var paginaactualexp=$("#bodi").attr("src").split("/");
		paginaactualexp.pop();

		for(var i=(exp.length-1); i>=0; i--){
			if(exp[i]==".."){
				paginaactualexp.pop();
				exp.splice(i, 1);
			}
		}
		paginaactualexp=paginaactualexp.concat(exp);
		tem=paginaactualexp.join("/");
		tem=tem.replace(book.bookfolder, "");
		tem=tem.replace("file:///", "");
		tem=tem.replace("file://", "");
		var pos=tem.indexOf("#");
		if(pos>0){
			//tem = tem.substring(0, pos);
		}
	}
	return tem;
}

function gotoAnchor(anchor){
	var doc = document.getElementById("bodi").contentDocument;
	//id con #
	var el=doc.getElementById(anchor);
    var mover=0;
	if(el){
	}else{
		//name
		anchor=anchor.replace("#", "");
		els=doc.getElementsByName(anchor);
		if(els.length>0){
			el=els[0];
		}else{
			//id sin #
			el=doc.getElementById(anchor);
			if(el){
			}
		}
	}
	if(el){
		mover=$(el).position().left;
		var ancho=window.innerWidth-20;
		var ira=Math.floor(mover/ancho);
		if(ira<0)
			ira=0;
	}else{
		ira=book.currentPage;
	}
	showPage(ira);
}

function findVisibleWord(){
	var doc = document.getElementById("bodi").contentDocument;
	if(book.currentPage==0 || book.currentPage==(book.currentNPages-1)){
		return null;
	}
	var cx=0+doc.body.scrollLeft;
	var cy=0;
	var texto=null;
	while(texto==null){
		try{
			texto = doc.caretRangeFromPoint(cx, cy);
		}catch(err){
		}
		cx+=20;
		if(cx >= window.innerWidth-20){
			cy+=10;
			cx=0;
		}
		if(cy>200){//si no encuentro palabra aqui lo doy por imposible.
			break;
		}
	}
	if(texto!=null){
		texto.expand("word");

		var startContainer=createXPathFromElement(texto.startContainer.parentNode);
		var endContainer=createXPathFromElement(texto.endContainer.parentNode);
		var startOffset=texto.startOffset;
		var endOffset=texto.endOffset;
		var startchild= getChildIndex(texto.startContainer);
		var endchild=getChildIndex(texto.endContainer);

		return {"startContainer": startContainer, "endContainer": endContainer, "startOffset": startOffset, "endOffset": endOffset, "startchild": startchild, "endchild": endchild, "page": book.currentPage, id:""};
	}else{
		return null;
	}
	unSelect();
}

/*
action bar actions
*/
function goBack(){
	if(book.history.length>1){
		book.history.pop();//este es la pagina actual
		bookmarkLoading=book.history.pop();//este la anterior
console.log(book.history);
		if(bookmarkLoading.currentPointer==book.currentPointer ){
			var page=bookmarkLoading.currentPage;
			bookmarkLoading=null;
			showPage(page);
		}else{
			var t=book.getUrl(book.spine[bookmarkLoading.currentPointer].src);
			if(t!=""){
				carga(t);
			}
		}
	}
}
function gotoToc(){
	//readingIframe=$("#bodi").contents();
	//document.getElementById("bodi").parentNode.removeChild(document.getElementById("bodi"));
	bb.pushScreen("readertoc.html", "readertoc", book);
}

/****
 * SEARCH FUNCTIONS
 */
function openSearch(){
	document.removeEventListener("touchstart", touchStart, false);
	document.removeEventListener("touchend", touchEnd, false);

    var doc = document.getElementById("bodi").contentDocument;
    doc.removeEventListener("selectionchange", selectionChange, false);
    doc.removeEventListener("touchstart", touchStart, false);
    doc.removeEventListener("touchend", touchEnd, false);

	$('#searchbar').toggle();
	$('#searchtext').focus();
	if(actBarTimer!=null)
		clearInterval(actBarTimer);
	document.getElementById('actbar').hide();
	$('#percentagebar').hide();

	$('#searchtext').keyup(function(e){
        if (e.keyCode == 13){
        	if( $('#searchtext').val().trim().length>2){
	        	$('#bodi').focus();
	        	searchtext=new SearchText();
	        	searchtext.searchDone=searchDone;
	        	searchPunt=-1;
	        	$('#searchresults').hide();
	        	$('#Spinner').show();
	        	searchtext.search($('#searchtext').val().trim(), book);
        	}else{
        		//Toast.regular("Please, add three or more letters", 2000);
        	}
        }
    });

	actBarVisible=false;
}
function searchDone(){
	$('#Spinner').hide();
	if(searchtext.files.length==0){
		Toast.regular($.localize.data['app'].searchnoresults, 3000);
	}else{
		$('#searchresults').show();
		$('#textresult').html(searchtext.files.length+" "+$.localize.data['app'].results);
	}
}
function searchNext(){
	if((searchPunt+1)<searchtext.getNumResults()){
		searchPunt++;
		$('#textresult').html((searchPunt+1)+" "+$.localize.data['app'].of+" "+searchtext.getNumResults());
		var o=searchtext.getResultAt(searchPunt);
		searchGo(o);
		/*
		searchResult.prevEnabled(false);
		if(searchPunt>0)
			searchResult.prevEnabled(true);
		searchResult.nextEnabled(false);
		if(searchPunt<searchText.getNumResults())
			searchResult.nextEnabled(true);
			*/
	}
}
function searchPrevious(){
	if(searchPunt>0){
		searchPunt--;
		$('#textresult').html((searchPunt+1)+" of "+searchtext.getNumResults());
		var o=searchtext.getResultAt(searchPunt);
		searchGo(o);
		/*
		searchResult.prevEnabled(false);
		if(searchPunt>0)
			searchResult.prevEnabled(true);
		searchResult.nextEnabled(false);
		if(searchPunt<searchText.getNumResults())
			searchResult.nextEnabled(true);
			*/
	}
}
function searchGo(o){
	searchObject=o;
	if(book.getCurrentChapterSrc()!=searchObject.src){
		wasSearching=true;
		carga(book.getUrl(searchObject.src));
	}else{
		search(searchObject.searchtext, searchObject.index);
	}
}
function findPositionString(str, texto, start){
	var pos=str.toLowerCase().indexOf(texto.toLowerCase(), start);
	return pos;
}
function cancelSearchHighlights(){
	$("#bodi").contents().find("[id^=seartext]").each( function() {
		var text = $(this).text();
   		$(this).replaceWith(text);
   	});
}
function search(texto, gotoindex){
	console.log(texto, gotoindex);
	var i=0;
	var punt=0;
	var found=false;
	var start=0;
	var desiredWidth=window.innerWidth-20;
	cancelSearchHighlights();
	var doc = document.getElementById("bodi").contentDocument;
	var elems=$("#bodi").contents().find("body").find('*:icontains('+texto+')');
	try{
			elems.each(function(){
				console.log("ELEM: ", $(this));
				var conhijosvalidos=0;
				//si este nodo tiene hijos pero ninguno de ellos contiene las palabras, el bueno es este.
				if($(this).children().length>0){
					var elems2=$(this).children(':icontains('+texto+')');
					conhijosvalidos=elems2.length;
				}
				if( $(this).prop('tagName')!="TITLE" && (conhijosvalidos < 1)) {
					var str=$(this).text();
				    var count = str.match(new RegExp(texto, "ig"));
				    var l=count.length;
				    console.log(conhijosvalidos+" bueno: "+gotoindex+" -> "+$(this).prop('tagName')+" ==>  "+$(this).text());
				    console.log("COINCIDENCIAS: "+l+" ==> "+str);
				    console.log("gotoindex: "+gotoindex+" ==> i: "+i);
				    start=0;
					if(l>1){
						if(gotoindex==i || gotoindex<=(i+l-1)){//there are more than one matches in this string and one of them is mine
							for(var m=0; m<l; m++){
								var pos=findPositionString(str, texto, start);
								if(gotoindex==(i+m)){
									i=gotoindex;
									break;
								}else{
									start=pos+texto.length;
								}
								//i++;
							}
						}else{
							//si no, deberia incrementar i en tantas coincidencias como hay no?
							i=i+l-1;
						}
					}
					if(gotoindex==i){
						console.log("gotoindex "+gotoindex);
						var str=$(this).text();
						var pos=str.toLowerCase().indexOf(texto.toLowerCase(), start);
						var len=texto.length;
						$(this).html(
								$(this).text().substring(0, pos)+'<span id="seartext'+gotoindex+'">'+$(this).text().substring(pos, pos+len)+'</span>'+$(this).text().substring(pos+len)
							);
						/*
								var range = doc.createRange();
								console.log($(this));
								console.log($(this)[0]);
								console.log(this);
								range.setStart(this, pos);
								range.setEnd(this, pos+len);

								var newNode = document.createElement("span");
								newNode.setAttribute('id', "seartext"+gotoindex);
								range.surroundContents(newNode);
								*/
						var p=Math.floor(($("#bodi").contents().find("#seartext"+gotoindex).offset().left)/desiredWidth);
						showPage(p);
						//$("#seartext"+gotoindex).css("color","#FFFFFF");
						//$("#seartext"+gotoindex).css("background-color","#000000");

						//if(isNight==1){
						//	$("#seartext"+gotoindex).addClass("searchtextnight");
						//}else{
						$("#bodi").contents().find("#seartext"+gotoindex).addClass("searchtext");
						//}
						found=true;
					}
					i++;
				}
				punt++;
				if(found==false && punt>=elems.length){
					showPage(0);
					$('#bodi').css("visibility", "visible");
				}
			});
	}catch(e){
		console.log(e);
		showPage(0);
	}
}
function cancelsearch(){
	cancelSearchHighlights();
    var doc = document.getElementById("bodi").contentDocument;
	document.addEventListener("touchstart", touchStart, false);
	document.addEventListener("touchend", touchEnd, false);
    doc.addEventListener("selectionchange", selectionChange, false);
    doc.addEventListener("touchstart", touchStart, false);
    doc.addEventListener("touchend", touchEnd, false);
    wasSearching=false;
    searchObject=null;
	$('#searchbar').hide();
	$('#searchresults').hide();
}





function gotoStart(){
	var t=book.getUrl(book.spine[0].src);
	book.currentPage=0;
	book.currentPointer=0;
	if(t!=""){
		carga(t);
	}
}
function gotoEnd(){
	var t=book.getUrl(book.spine[book.spine.length-1].src);
	book.currentPage=10000;
	book.currentPointer=book.spine.length-1;

	if(t!=""){
		carga(t);
	}

}
function openBookmarks(){
	//readingIframe=$("#bodi").contents();
	//document.getElementById("bodi").parentNode.removeChild(document.getElementById("bodi"));
	bb.pushScreen("readerbookmarks.html", "readerbookmarks", book);
}
function openNotes(){
	//readingIframe=$("#bodi").contents();
	//document.getElementById("bodi").parentNode.removeChild(document.getElementById("bodi"));
	bb.pushScreen("readernotes.html", "readernotes", book);
}
function bookSettings(){
	/*
    blackberry.invoke.invoke({
    	action: "bb.action.VIEW",
        target: "com.xplota.playepub.settings",
        type: "text/plain",
        data: "{'myData': 'A string I pass to another app'}"
    }, function(){
    	console.log("sucess card");
    }, function(){
    	console.log("error card");
    });
    return;
    */
	bb.pushScreen("readersettings.html", "readersettings", book);
}

function updateFromCloud(){
	if(cloudsync.isEnabled()){
		cloudsync.getBook(book);
	}else{
		//readingIframe=$("#bodi").contents();
		//document.getElementById("bodi").parentNode.removeChild(document.getElementById("bodi"));
		bb.pushScreen("settingsCloudSync.html", "settingsCloudSync");
	}
}

/*
notes and bookmarks
*/
function showNotesFavoritesHighlighted(){
	var po=0;
	for(var i=0; i<book.notes.length; i++){
		var n=book.notes[i];
		if(n.pointer==book.currentPointer && n.position){
			var color=0xFFFF00;
			if(n.color){
				color=n.color;
			}
			setHighlight(n.position.startContainer, n.position.endContainer, n.position.startOffset, n.position.endOffset, n.position.startchild, n.position.endchild, 'highlight', 'note_'+n.date, color.toString(16));
		}
		po++;
	}
	po=0;
	for(var i=0; i<book.bookmarks.length; i++){
		var n=book.bookmarks[i];
		if(n.pointer==book.currentPointer && n.position){
			setHighlight(n.position.startContainer, n.position.endContainer, n.position.startOffset, n.position.endOffset, n.position.startchild, n.position.endchild, 'highlightbookmark', 'bk_'+n.date, '');
		}
		po++;
	}
	po=0;
	for(var i=0; i<book.highlights.length; i++){
		var n=book.highlights[i];
		if(n.pointer==book.currentPointer && n.position){
			setHighlight(n.position.startContainer, n.position.endContainer, n.position.startOffset, n.position.endOffset, n.position.startchild, n.position.endchild, 'highlight', 'highl_'+n.date, n.color.toString(16));
		}
		po++;
	}
}

function findActiveBookmark(){
	var isBookmark=false;
	var desiredWidth=window.innerWidth-20;
	$("#bodi").contents().find("[id^=bk_]").each( function() {
		var p=Math.floor($(this).offset().left/desiredWidth);
		if(book.currentPage==p){
			isBookmark=$(this).attr('id');
		}
	});
	console.log("findActiveBookmark: "+isBookmark);

	return isBookmark;
}
function findActiveHighlight(){
	console.log(selectionPosition);
	var o1=lookupElementByXPath(selectionPosition.startContainer);
	var o2=lookupElementByXPath(selectionPosition.endContainer);

	var id="";
	if(o1.id && o1.id.substring(0, 6)=="highl_" && o2.id && o2.id.substring(0, 6)=="highl_"){
		id=o1.id;
		console.log("findActiveHighlight: "+id);
		return id;
	}
	return false;
}
function setHighlight(startnode, endnode, startpos, endpos, startchild, endchild, clase, id, color){
	try{
		if(color=="")
			color="FFC02D";
		if(color.length<6){
			var t=6-color.length;
			for(var r=0; r<t; r++){
				color="0"+color;
			}
		}
		console.log("startnode: "+startnode+" endnode: "+endnode+" startpos: "+startpos+" endpos: "+endpos+" startchild: "+startchild+" endchild: "+endchild+" clase: "+clase+" id: "+id+" color: "+color);

		var o1=lookupElementByXPath(startnode).childNodes[startchild];
		var o2=lookupElementByXPath(endnode).childNodes[endchild];
		var punt=0;
		if(startnode==endnode){
			doSetHighlight(o1, o2, startpos, endpos, clase, id, color);
		}else{
			var xPathResult = document.getElementById("bodi").contentDocument.evaluate('.//text()[normalize-space(.) != ""]', document.getElementById("bodi").contentDocument.body, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
			console.log(xPathResult);
			var startFound=false;
			var l = xPathResult.snapshotLength;
			for (var i = 0; i < l; i++) {
				var textNode = xPathResult.snapshotItem(i);
				if(textNode==o1){
					startFound=true;
					var tamano=o1.nodeValue.length;
					doSetHighlight(o1, o1, startpos, tamano, clase, id, color);
					continue;
				}
				if(startFound && textNode!=o2){
					//alert("middle node found \n\n"+textNode.nodeValue);
					//es un nodo completo entre inicio y final
					var tamano=textNode.nodeValue.length;
					doSetHighlight(textNode, textNode, 0, tamano, clase, id+"_"+punt, color);
					punt++;
				}
				if(textNode==o2){
					//alert("end found "+endpos);
					doSetHighlight(o2, o2, 0, endpos, clase, id+"_"+punt, color);
					break;
					punt++;
				}
			}
		}
	}catch(e){
		//alert(e);
	}
}

function hexToR(h) {return parseInt((cutHex(h)).substring(0,2),16);};
function hexToG(h) {return parseInt((cutHex(h)).substring(2,4),16);};
function hexToB(h) {return parseInt((cutHex(h)).substring(4,6),16);};
function cutHex(h) {return (h.charAt(0)=="#") ? h.substring(1,7):h;};

function doSetHighlight(o1, o2, startpos, endpos, clase, id, color){
	console.log("doSetHighlight", o1, o2, startpos, endpos, clase, id, color);

	var doc = document.getElementById("bodi").contentDocument;

	try{
		var range = doc.createRange();
		range.setStart(o1, startpos);
		range.setEnd(o2, endpos);

		var newNode = document.createElement("span");


		newNode.setAttribute('class', clase);
		newNode.className=clase;
		newNode.setAttribute('style', "background-color: #"+color+" !important;");
		if(id!=-1){
			newNode.id=id;
			newNode.setAttribute('id', id);
		}
		range.surroundContents(newNode);
		console.log(newNode);
	}catch(err){
		console.log(err);
	}
}


function loadBookmarks(params){
	console.log("loadBookmarks");
	book=params;
	var items=[];
	for(var i in book.bookmarks){
		var b=book.bookmarks[i];
		var item = document.createElement('div');
		item.setAttribute('data-bb-type','item');
		item.setAttribute('data-bb-title', b.label);
		item.setAttribute('identifier', b.date);
		item.onclick = clickBookmark;
		items.push(item);
	}
	console.log(items);
	document.getElementById('bookmarkslist').refresh(items);
	if(items.length==0)
		document.getElementById('bookmarkslist').clear();
}
function clickBookmark(){
	var selected = document.getElementById('bookmarkslist').selected;
	var id=selected.getAttribute("identifier");
	openBookmark(id);
}
function gotoBookmark(){
    var context = document.getElementById('contextlist');
	var selected=context.menu.selected.selected;
	var id=selected.getAttribute("identifier");
	openBookmark(id);
}
function openBookmark(id){
	console.log("openBookmark "+id);
	for(var i in book.bookmarks){
		var b=book.bookmarks[i];
		if(b.date==id){
			book.currentPage=b.page;
			book.currentPointer=b.pointer;
			book.currentPosition=b.position;
			book.currentPosition.id='bk_'+b.date;
			book.currentPosition.page=b.page;
			book.saveBook();
			bb.popScreen();
			break;
		}
	}
}
function removeBookmark(){
    var context = document.getElementById('contextlist');
	var selected=context.menu.selected.selected;
	var id=selected.getAttribute("identifier");
	book.removeBookmark(id);

	selected.remove();
	book.lastsynced=book.lastsynced+1;
	book.saveBook();
	cloudsync.saveBookBookmarks(book);
}


/*
 * NOTES
*/

function loadNotes(params){
	book=params;
	var items=[];
	for(var i in book.notes){
		var b=book.notes[i];
		var item = document.createElement('div');
		item.setAttribute('data-bb-type','item');
		item.setAttribute('data-bb-title', b.label);
		item.setAttribute('identifier', b.date);
		item.onclick = clickNote;
		items.push(item);
	}
	console.log(items);
	document.getElementById('bookmarkslist').refresh(items);
	if(items.length==0)
		document.getElementById('bookmarkslist').clear();
}

function clickNote(){
	var selected = document.getElementById('bookmarkslist').selected;
	var id=selected.getAttribute("identifier");
	openNote(id);
}
function gotoNote(){
    var context = document.getElementById('contextlist');
	var selected=context.menu.selected.selected;
	var id=selected.getAttribute("identifier");
	openNote(id);
}
function openNote(id){
	console.log("opennote "+id);
	for(var i in book.notes){
		var b=book.notes[i];
		if(b.date==id){
			book.currentPage=b.page;
			book.currentPointer=b.pointer;
			book.currentPosition=b.position;
			book.currentPosition.id='note_'+b.date;
			book.currentPosition.page=b.page;
			book.saveBook();
			bb.popScreen();
			break;
		}
	}
}
function copyNote(id){
    var context = document.getElementById('contextlist');
	var selected=context.menu.selected.selected;
	var id=selected.getAttribute("identifier");

	for(var i in book.notes){
		var b=book.notes[i];
		if(b.date==id){
			copyToClipboard(b.label);
			Toast.regular($.localize.data['app'].copiedtoclipboard, 3000);
			break;
		}
	}
}
function copyToClipboard(text){
	var result = community.clipboard.setText(text);
	console.log(result);
}
function viewNote(id){
    var context = document.getElementById('contextlist');
	var selected=context.menu.selected.selected;
	var id=selected.getAttribute("identifier");

	for(var i in book.notes){
		var b=book.notes[i];
		if(b.date==id){
			break;
		}
	}
}

function removeNote(){
    var context = document.getElementById('contextlist');
	var selected=context.menu.selected.selected;
	var id=selected.getAttribute("identifier");
	book.removeNote(id);
	selected.remove();
	book.lastsynced=book.lastsynced+1;
	book.saveBook();
	cloudsync.saveBookNotes(book);
}


function configureSettings(){
	var standby=localStorage.getItem("standby");
	blackberry.display.setPreventSleep(standby == "true", function(){console.log('setPreventOK');}, function(){console.log('setPrevent KO');});

	var state=(localStorage.getItem("rotation") == "true");
	var orientation=blackberry.app.orientation;
	if(state){
		blackberry.app.lockOrientation(orientation);
	}else{
		blackberry.app.unlockOrientation();
	}

	watchformat=(localStorage.getItem("watchformat") == "true");
	withSwipeChapters=(localStorage.getItem("swipe") == "true");
	withpageflip=(localStorage.getItem("pageflip") == "true");

	withtouchkeyboard=localStorage.getItem("swipetouckkeyboard");
	//lo inicializo a true por defecto
	if(!withtouchkeyboard){
		withtouchkeyboard="true";
		localStorage.setItem("swipetouckkeyboard", "true");
	}
	withtouchkeyboard=(withtouchkeyboard == "true");

	withtouchscreen=localStorage.getItem("swipetouckscreen");
	if(!withtouchscreen){
		withtouchscreen="true";
		localStorage.setItem("swipetouckscreen", "true");
	}
	withtouchscreen=(withtouchscreen == "true");

	var volume=(localStorage.getItem("volume") == "true");
	if(volume){
		doVolumeOnResume();
		document.addEventListener("pause", doVolumeOnPause, false);
		readerEvents.push({name: "pause", callback: doVolumeOnPause});
		document.addEventListener("resume", doVolumeOnResume, false);
		readerEvents.push({name: "resume", callback: doVolumeOnResume});
		//document.addEventListener("volumedownbutton", prevPage, false);
		//document.addEventListener("volumeupbutton", nextPage, false);
	}
	doWatch();
	setInterval(doWatch, 60000);
}
function doVolumeOnPause(){
	console.log("PAUSE");
	var mediaKeyDownLong = {
	    mediakey: "volumeDown",
	    keylength: "long",
	    onPressed: function() { console.log("bind volume down (short) succeeded to null"); }
	};
	var mediaKeyUpLong = {
	    mediakey: "volumeUp",
	    keylength: "long",
	    onPressed: function() { console.log("bind volume up (long) succeeded to null"); }
	};

	var keyBindings = [];
	community.mediakeys.bind(keyBindings, function (error) { console.log("unable to bind media keys: "+error); });
}
function doVolumeOnResume(){
	console.log("RESUME");
	var mediaKeyDownLong = {
	    mediakey: "volumeDown",
	    keylength: "long",
	    onPressed: function() { console.log("bind volume down (short) succeeded"); prevPage();}
	};
	var mediaKeyUpLong = {
	    mediakey: "volumeUp",
	    keylength: "long",
	    onPressed: function() { console.log("bind volume up (long) succeeded"); nextPage();}
	};

	var keyBindings = [mediaKeyDownLong, mediaKeyUpLong];
	community.mediakeys.bind(keyBindings, function (error) { console.log("unable to bind media keys: "+error); });
}
function loadSettings(){
	var ancho=window.innerWidth;
	console.log("ANCHO "+ancho);
	if(ancho>1400)//is passport
		$('.keyboardgesturespassport').show();

	var standby=localStorage.getItem("standby");
	document.getElementById("standbyToggle").setChecked((standby == "true"));

	var rotation=localStorage.getItem("rotation");
	document.getElementById("rotationToggle").setChecked((rotation == "true"));

	var watchformat=localStorage.getItem("watchformat");
	document.getElementById("watchToggle").setChecked((watchformat == "true"));

	var swipe=localStorage.getItem("swipe");
	document.getElementById("swipeToggle").setChecked((swipe == "true"));

	var touchkeyboard=localStorage.getItem("swipetouckkeyboard");
	document.getElementById("swipetouckkeyboard").setChecked((touchkeyboard == "true"));

	var touchscreen=localStorage.getItem("swipetouckscreen");
	document.getElementById("swipetouckscreen").setChecked((touchscreen == "true"));

	var flip=localStorage.getItem("pageflip");
	document.getElementById("swipeFlip").setChecked((flip == "true"));

	var volume=localStorage.getItem("volume");
	document.getElementById("volumeToggle").setChecked((volume == "true"));

	var color=localStorage.getItem("highlight-color");
	if(!color)
		color="#FFA500";
	$('#highlightColor').val(color);
}


function changeRotation(){
	var orientation=blackberry.app.orientation;
	var state=document.getElementById("rotationToggle").getChecked();
	localStorage.setItem("rotation", state);

	if(state){
		console.log("LOCK");
		blackberry.app.lockOrientation(orientation);
	}else{
		console.log("UNLOCK");
		blackberry.app.unlockOrientation();
	}
}

function changeStandBy(){
	var state=document.getElementById("standbyToggle").getChecked();
	localStorage.setItem("standby", state);

	console.log(state);
	blackberry.display.setPreventSleep(state, function(){console.log('setPreventOK');}, function(){console.log('setPrevent KO');});
}
function changeWatchFormat(){
	var state=document.getElementById("watchToggle").getChecked();
	localStorage.setItem("watchformat", state);
}
function changeSwipeChapters(){
	var state=document.getElementById("swipeToggle").getChecked();
	localStorage.setItem("swipe", state);
}
function changeTouchKeyboard(){
	var state=document.getElementById("swipetouckkeyboard").getChecked();
	localStorage.setItem("swipetouckkeyboard", state);
	if(!state){//si está en disabled, screen tiene que estar enabled
		document.getElementById("swipetouckscreen").setChecked(true);
	}
}
function changeTouchScreen(){
	var state=document.getElementById("swipetouckscreen").getChecked();
	localStorage.setItem("swipetouckscreen", state);
	if(!state){//si está en disabled, keyboard tiene que estar enabled
		document.getElementById("swipetouckkeyboard").setChecked(true);
	}
}
function changePageFlip(){
	var state=document.getElementById("swipeFlip").getChecked();
	localStorage.setItem("pageflip", state);
}
function changeVolumePages(){
	var state=document.getElementById("volumeToggle").getChecked();
	localStorage.setItem("volume", state);
}
function changeHighlightColor(){
	var state=$('#highlightColor').val();
	console.log("COLOR: "+state);
	localStorage.setItem("highlight-color", state);
}

function setBookCover(){
	console.log("setBookCover", book.cover.replace("file://", ""));
	filesystem.root.getFile(book.cover.replace("file://", ""), {}, function(fileEntry) {
		filesystem.root.getDirectory("/accounts/1000/shared/misc/playepubcovers", {create:true}, function(dirEntry) {
			fileEntry.copyTo(dirEntry, "cover.png", function(){
			  	var covers = [], fullsize = new blackberry.ui.cover.Cover('fullSize',
						blackberry.ui.cover.TYPE_IMAGE), halfsize = new blackberry.ui.cover.Cover(
						'halfSize', blackberry.ui.cover.TYPE_IMAGE);

				fullsize.width = 334;
				fullsize.height = 396;
				//fullsize.text.push(new blackberry.ui.cover.Label(book.title, 10));
				fullsize.path = "file:///accounts/1000/shared/misc/playepubcovers/cover.png";
				console.log(fullsize.path);


				halfsize.width = 310;
				halfsize.height = 211;
				//halfsize.text.push(new blackberry.ui.cover.Label(book.title, 10));
				fullsize.path = "file:///accounts/1000/shared/misc/playepubcovers/cover.png";

				covers.push(fullsize);
				covers.push(halfsize);

				blackberry.ui.cover.updateCovers(covers, function() {
					console.log('Covers updated');
				}, function() {
					console.log('Cover update error');
				});
			},
			function(e){
				console.log(e);
			});
		}, function(e){
			console.log(e);
		});

	}, function(e){console.log("cover error"); console.log(e);});
}


function createContext(){
	blackberry.ui.contextmenu.enabled=false;
};

function addShare(){
    var title = 'Share';
    var request = {
        action: 'bb.action.SHARE',
        mime : 'text/plain',
        data: getSelection(),
        target_type: ["APPLICATION", "VIEWER", "CARD"]
    };
    blackberry.invoke.card.invokeTargetPicker(request, title, function(msg) {}, function(e) {});
    unSelect();
}
function addBBM(){
	blackberry.bbm.platform.self.setPersonalMessage(
		getSelection(),
		function (accepted) {
			console.log(accepted);
		}
	);
	unSelect();
}
function addGoogle(){
	var url="http://google.com/search?q="+escape(getSelection());
    blackberry.invoke.invoke({
    	target: "sys.browser",
        uri: url
    }, function(){}, function(){});
    unSelect();
}
function addCopy(){
	copyToClipboard(getSelection());
	Toast.regular($.localize.data['app'].copiedtoclipboard, 3000);
	unSelect();
}
function addTranslate(){
	bb.pushScreen("readertranslator.html", "readertranslator", {book: book, text: getSelection(), position: selectionPosition});
}
function addDictionary(){
	bb.pushScreen("readerdictionary.html", "readerdictionary", {book: book, text: getSelection(), position: selectionPosition});
}

function addHighlight(){
	var bid=findActiveHighlight();
	if(bid){
		book.removeHighlight(parseInt(bid.replace("highl_", "")));
		unSetHighlight(bid);
	}else{
		var tempo={};
		tempo.page=book.currentPage;
		tempo.npage=book.currentNPages;
		tempo.pointer=book.currentPointer;
		tempo.label=getSelection();
		if(tempo.label=="")
				tempo.label=$.localize.data['app'].page+" "+(Number(actualPagePage)+1);
		tempo.date=new Date().getTime();
		tempo.position=selectionPosition;
		var highcolor=localStorage.getItem("highlight-color");
		if(!highcolor)
			highcolor="#FFA500";
		highcolor=highcolor.substring(1);
		highcolor=parseInt("0x"+highcolor, 16);
		console.log("hex color:" +highcolor);
		tempo.color=highcolor;
		book.highlights.push(tempo);
		var n=book.highlights[book.highlights.length-1];
		console.log(n);
		setHighlight(n.position.startContainer, n.position.endContainer, n.position.startOffset, n.position.endOffset, n.position.startchild, n.position.endchild, 'highlight', 'highl_'+n.date, n.color.toString(16));
	}
	unSelect();
	book.lastsynced=book.lastsynced+1;
	book.saveBook();
	cloudsync.saveBookHighlights(book);
}
function addNoteScreen(){
	bb.pushScreen("readeraddnote.html", "readeraddnote", {book: book, position: selectionPosition, text: getSelection()});
}
var notePosition=null;
function loadAddNote(params){
	notePosition=params.position;
	$('#note').val(params.text);


	var color=localStorage.getItem("note-color");
	if(!color)
		color="#FFFF00";
	$('#notecolor').val(color);

}
function addNote(){
	var tempo={};
	tempo.page=book.currentPage;
	tempo.npage=book.currentNPages;
	tempo.pointer=book.currentPointer;
	tempo.label=$('#note').val();
	tempo.date=new Date().getTime();
	tempo.position=notePosition;

	var state=$('#notecolor').val();
	localStorage.setItem("note-color", state);
	state=state.substring(1);
	state=parseInt("0x"+state, 16);
	tempo.color=state;

	book.notes.push(tempo);
	book.lastsynced=book.lastsynced+1;
	book.saveBook();
	cloudsync.saveBookNotes(book);
	bb.popScreen();
}
function addBookmark(){
	var bid=findActiveBookmark();
	if(bid){
		book.removeBookmark(parseInt(bid.replace("bk_", "")));
		unSetHighlight(bid);
	}else{
		var tempo={};
		tempo.page=book.currentPage;
		tempo.npage=book.currentNPages;
		tempo.pointer=book.currentPointer;
		tempo.label=getSelection();
		if(tempo.label=="")
				tempo.label=$.localize.data['app'].page+" "+(Number(actualPagePage)+1);
		tempo.date=new Date().getTime();
		tempo.position=selectionPosition;
		book.bookmarks.push(tempo);
		book.lastsynced=book.lastsynced+1;
		book.saveBook();
		cloudsync.saveBookBookmarks(book);
		unSelect();
		var n=book.bookmarks[book.bookmarks.length-1];
		setHighlight(n.position.startContainer, n.position.endContainer, n.position.startOffset, n.position.endOffset, n.position.startchild, n.position.endchild, 'highlightbookmark', 'bk_'+n.date, '');
	}
	unSelect();
}
function getSelection(){
	var doc = document.getElementById("bodi").contentDocument;
	var selection=doc.getSelection().toString();
	return selection;
}
function doChangePercentage(value){
	$('#percentagelabel').html(value+"%");
}


/*******
 *
 *
 */
function onKeyPress(e){
	console.log(e );
	if(e.keyDown){
		switch(e.alternateCharacter ){
			case 61526://space
				nextPage();
				break;
			case 61525://shift+space, Z
			case 122:
				prevPage();
				break;
			case 61520://T
				gotoStart();
				break;
			case 61527://B
				gotoEnd();
				break;
			case 62003://N
				nextChapter();
				break;
			case 62002://P
				//prev chapter, no llamo a prev() porque iria a la ulrima pagina del chapter
				var t=book.getPrevChapter();
				if(t!=""){
					book.currentPage=0;
					carga(t);
				}
				break;
			case 62010://I-increase font size
				var fontsize=parseInt(localStorage.getItem("fontsize"))*10;
				if(fontsize<400){
					fontsize=fontsize/10;
					fontsize++;
					console.log("NEW FONT: "+fontsize);
					setFontSize(fontsize, true);
				    document.getElementById("fontsize").setValue(parseInt(parseFloat(fontsize)*10));
				}
				break;
			case 62011://O-decrease font size
				var fontsize=parseInt(localStorage.getItem("fontsize"))*10;
				console.log("fontsize: "+fontsize);
				if(fontsize>130){
					fontsize=fontsize/10;
					fontsize--;
					setFontSize(fontsize, true);
					console.log("fontsize: "+fontsize);
					console.log("fontsize: "+parseInt(parseFloat(fontsize)*10));
				    document.getElementById("fontsize").setValue(parseInt(parseFloat(fontsize)*10));
				}
				break;
			case 61998://S
				openSearch();
				break;
			case 8:
			case 46:
				bb.popScreen();
				break;
		}
	}
}
function onMenuButton(){
	console.log("onMenuButton");
	  document.getElementById('actbar').show();
	  showPercentageSlider();
	  actBarVisible=true;
	  hideActionBar();
}
function onBackButton(){
	goBack();
}

//BLACKBERRY PASSPORT TOUCH KEYBOARD
//SOPORTA OCULTAR BARRA Y PREV/NEXT
var touchTimestamp=null;
function touchKeyboardCallback(e){
	if(!withtouchkeyboard)
		return;
	console.log("touchKeyboardCallback", e);
	var touchobj = e.touches[0];
	if (touchobj.state == "TouchPressed") {
		startPosX = parseInt(touchobj.keyboardX);
		startPosY = parseInt(touchobj.keyboardY);
	} else if (touchobj.state == "TouchReleased") {
		if(e.timeStamp==touchTimestamp)//duplicado
			return;
		touchTimestamp=e.timeStamp;
		var xdiff = touchobj.keyboardX - startPosX;
		// xdiff>100=>swipe right
		// xdiff< -100=>swipe right

		if (actBarVisible || actBarTimer != null) {
			// actbar visible y con timer para ocultarla
			if (actBarTimer != null)
				clearInterval(actBarTimer);
			document.getElementById('actbar').hide();
			$('#percentagebar').hide();
			actBarVisible = false;
			actBarTimer = null;
		} else if (withSwipeChapters && xdiff > 100) {// swipe right
			nextChapter();
		} else if (withSwipeChapters && xdiff < -100) {// swipe left
			var t=book.getPrevChapter();
			if(t!=""){
				book.currentPage=0;
				carga(t);
			}
		} else if (!withSwipeChapters && xdiff > 100) {// swipe right
			prevPage();
		} else if (!withSwipeChapters && xdiff < -100) {// swipe left
			nextPage();
		} else if (parseInt(touchobj.keyboardX) >= (window.innerWidth / 2)) {
			nextPage();
		} else if (parseInt(touchobj.keyboardX) < (window.innerWidth / 2)) {
			prevPage();
		}
	}
}

function showPercentageSlider(){
	$('#percentagebar').show();
	  var percent=book.getPercentage();
	  document.getElementById('percentage').setValue(percent);
	  $('#percentagelabel').html(percent+"%");
}

function initCloudSync(){
	cloudsync.dispatchPosition=function(loadedinfo){
		console.log("loadedinfo", loadedinfo);
		book.bookmarks=JSON.parse(loadedinfo.bookmarks);
		book.notes=JSON.parse(loadedinfo.notes);
		book.highlights=JSON.parse(loadedinfo.highlights);
		book.lastsynced=loadedinfo.lastupdate;
		var items=loadedinfo.position.split("|");
		if(items.length>=3){
			book.currentPage=parseInt(items[0]);
			book.currentNPages=parseInt(items[1]);
			book.currentPointer=parseInt(items[2]);
			book.useBookStyles=items[3];
		}
		book.saveBook();
		lastVisibleWord=loadedinfo.realposition;
		bookLoaded=true;

		//habria que comprobar si es distinto!
		var src=book.getCurrentChapterSrc();
		var arch=book.getUrl(src);
		carga(arch);
	};
	cloudsync.dispatchSaveFull=function(){
		console.log("dispatchSaveFull");
		bookLoaded=true;
		cloudsync.saveBook(book, visibleWord);
	};
	cloudsync.dispatchKO=function(){
		Toast.regular($.localize.data['app'].errorconnectingcloudsync, 3000);
	};
	cloudsync.dispatchOK=function(){
		bookLoaded=true;
	};
	cloudsync.dispatchUpdateCurrent=function(){
		var js=JSON.stringify(visibleWord);
		cloudsync.saveBook(book, js);
	};
	cloudsync.getBook(book);
}



/*********************
VOICE
*********************/
var voicestatus=0;//stoped
var googleTTS = new window.GoogleTTS();
var oldPageflip=withpageflip;

function initVoiceControls(){
	var langs=googleTTS.languages();
	var dropdown = document.getElementById('voicelanguage');

	$('#voiceclose').click(function(){
		console.log("CLOSE VOICE");
		document.addEventListener("touchstart", touchStart, false);
		document.addEventListener("touchend", touchEnd, false);
		var standby=localStorage.getItem("standby");
		blackberry.display.setPreventSleep(standby == "true", function(){console.log('setPreventOK');}, function(){console.log('setPrevent KO');});

		var state=(localStorage.getItem("rotation") == "true");
		if(!state){
			blackberry.app.unlockOrientation();
		}


		unSetHighlight('currentpos');
		try{
			googleTTS.stop();
		}catch(e){};
		voicestatus=0;
		withpageflip=oldPageflip;
		var doc1 = document.getElementById("bodi").contentDocument;
		doc1.addEventListener("selectionchange", selectionChange, false);
		blackberry.event.addEventListener("swipedown", showSwipeDownMenu);
		$('#voicecontrols').css("visibility", "hidden");
	});
	if($('#voicelanguage').val()==0)
		$('#voiceicon').hide();
	else
		$('#voiceicon').show();

	$('#voiceicon').click(function() {
		console.log("CLICK");
		console.log("voicestatus: ", voicestatus);
		switch(voicestatus){
		case 0://stoped
			dropdown.hide();
			speechPage();
			break;
		case 1://playing
			pauseSpeech();
			break;
		case 2://paused
			resumeSpeech();
			break;
		}
	});
}
function pauseSpeech(){
	googleTTS.pause();
	$('#voiceicon').attr("src", "assets/voiceplay.png");
	voicestatus=2;
}
function resumeSpeech(){
	googleTTS.resume();
	$('#voiceicon').attr("src", "assets/voicepause.png");
	voicestatus=1;
}
function speechPage(){
	if(!googleTTS.isConnected()){
		Toast.regular("You need to be connected to use this feature", 3000);
		return;
	}
	$('#voiceicon').attr("src", "assets/voicepause.png");
	voicestatus=1;
	withpageflip=false;

	if(!book.currentVoicePosition.pointer){
		book.currentVoicePosition={chapter: book.currentPointer, pointer: 0, page: book.currentPage, npages:book.currentNPages};
	}else{
		if(book.currentPointer!=book.currentVoicePosition.chapter || book.currentNPages!=book.currentVoicePosition.npages || book.currentPage!=book.currentVoicePosition.page){
			book.currentVoicePosition={chapter: book.currentPointer, pointer: 0, page: book.currentPage, npages:book.currentNPages};
		}
	}
	book.currentVoicePosition.lang=$('#voicelanguage').val();
	book.saveBook();
	console.log($('#voicelanguage').val());
	var texto=getAllTextInColumn();
	texto=texto.trim();
	if(texto==""){
		nextPage();
	}else{
		googleTTS.play(texto, $('#voicelanguage').val(), book.currentVoicePosition.pointer, function(err) {
		    if (err) {
		  	  console.log(err);
		    }
		    //nextChapter();
		  });
	}
}
function setVoiceLanguage(){
	if($('#voicelanguage').val()!=0){
		$('#voiceicon').show();
	}else{
		$('#voiceicon').hide();
	}
}

function comfirmSpeechWithData(){
	//get from local preferences dont show again
	var dontshow=(localStorage.getItem("speechDontShowAgain")== "true");

	if(blackberry.connection.type!=blackberry.connection.NONE && blackberry.connection.type!=blackberry.connection.WIFI){
		if(dontshow){
			startReading();
		}else{
		   try {
				var buttons = ["OK", "Don't show again", "Cancel"];
				var ops = {title : "Online service"};
				blackberry.ui.dialog.customAskAsync("This feature uses an online service and your carrier might apply charges.<br>Continue?", buttons, function(index){
					switch(index){
					case 0:
						startReading();
						break;
					case 1:
						//save on local preferences
						localStorage.setItem("speechDontShowAgain", "true");
						startReading();
						break;
					case 2:
						break;
					}
				}, ops);
		   } catch(e) {
				console.log("Exception in customDialog: " + e);
				startReading();
		   }
		}
	}else{
		startReading();
	}
}
function startReading(){
	oldPageflip=withpageflip;

	blackberry.display.setPreventSleep(true, function(){console.log('setPreventOK');}, function(){console.log('setPrevent KO');});
	blackberry.event.removeEventListener("swipedown", showSwipeDownMenu);
	var doc1 = document.getElementById("bodi").contentDocument;
	doc1.removeEventListener("selectionchange", selectionChange, false);
	blackberry.app.lockOrientation(blackberry.app.orientation);

	var dropdown = document.getElementById('voicelanguage');

	//book.currentVoicePosition.lang
	if(dropdown.options.length==1){
		var selecteditem=0;
		var i=0;
	    $.each(googleTTS.languages(), function(key, value) {
	        option = document.createElement('option');
	        option.setAttribute('value',key);
	        option.innerHTML = value;
	        dropdown.appendChild(option);
	        i++;
	        if(book.currentVoicePosition.lang && book.currentVoicePosition.lang==key){
	        	selecteditem=i;
	        }
	      });
	    dropdown.refresh();
	    dropdown.setSelectedItem(selecteditem);
	}
	dropdown.show();

	voicestatus=0;
	googleTTS = new window.GoogleTTS();
	googleTTS.loading=function(){
		$('#voicespin').show();
	};
	googleTTS.stoploading=function(){
		$('#voicespin').hide();
	};
	googleTTS.nextItem=function(texto){
		console.log("NEXT ITEM ", googleTTS.playpointer);
		console.log("TEXTO: "+texto);
		highlightVoiceText(texto);
		book.currentVoicePosition.pointer=googleTTS.playpointer;
		book.saveBook();
	};
	googleTTS.connectionError=function(){
		console.log("CONNECTION ERROR");
		Toast.regular("There is no Internet connection", 3000);
		var dis=new Audio();
		unSetHighlight('currentpos');
		$('#voicespin').hide();
		pauseSpeech();
		voicestatus=0;
		dis.src="assets/disconnect.mp3";
		dis.play();

		//si tengo conexion, pruebo el captcha
		if(blackberry.connection.type!=blackberry.connection.NONE){
			var url="http://translate.google.com/translate_tts?tl=es&q=this%20is%20a%20test";
			var popup=window.open(url);
			/*
		    window.int = self.setInterval(function() {
		    	console.log("CHECKING URL "+popup.location.href);
				var inCallback = (popup.location.href.indexOf("sorry")<0);
		        if (inCallback) {
		        	window.clearInterval(int);
		        	popup.close();
		        }
		    }, 1000);
	        */
		}
	};
	googleTTS.nextPage=function(){
		pauseSpeech();
		voicestatus=1;
		nextPage();
	};
	$('#voicespin').hide();
	document.removeEventListener("touchstart", touchStart, false);
	document.removeEventListener("touchend", touchEnd, false);
	$('#voiceicon').css("top", (window.innerHeight-$('#voiceicon').height())/2+"px");
	$('#voiceicon').css("left", (window.innerWidth-$('#voiceicon').width())/2+"px");

	$('#voiceicon').attr("src", "assets/voiceplay.png");
	$('#voicecontrols').css("visibility", "visible");
}


function getAllTextInColumn(){
	var ancho=window.innerWidth-20;
	var alto=window.innerHeight-70-75;//menos las barras de arriba y abajo
	var rect={top: 0, left: 0, width: ancho, height: alto};
    /*
        rect should be the size and x,y of the column
        { top, left, width, height }
    */
	var doc = document.getElementById("bodi").contentDocument;
    if(doc.caretRangeFromPoint){
        var caretRangeStart = doc.caretRangeFromPoint(rect.left, rect.top);
        var caretRangeEnd = doc.caretRangeFromPoint(rect.left+rect.width-1, rect.top+rect.height-1);
    } else {
        return null;
    }

    if(caretRangeStart == null || caretRangeEnd == null) return null;

    var range = doc.createRange();
    range.setStart(caretRangeStart.startContainer, caretRangeStart.startOffset);
    range.setEnd(caretRangeEnd.endContainer, caretRangeEnd.endOffset);

    return range.toString();
};

function highlightVoiceText(texto){
	unSetHighlight('currentpos');

	var doc = document.getElementById("bodi").contentWindow;
	doc.getSelection().removeAllRanges();
	if(doc.find(texto, false, false)){
		var doc1 = document.getElementById("bodi").contentDocument;
		var sel = doc1.getSelection();
	    if (sel.rangeCount) {
	        var span = document.createElement("span");
	        span.setAttribute('class', 'currentpos');
	        span.className='currentpos';
			span.id="currentpos";
			try{
				var range = sel.getRangeAt(0);//.cloneRange();
				range.surroundContents(span);
				//sel.addRange(range);
			}catch(e){
				console.log(e);
			}
	    }
	    doc.getSelection().removeAllRanges();
	    var bodi = $("#bodi").contents().find("body");
	    bodi.scrollLeft(bodi.outerWidth()*book.currentPage);
	}
}
