var testsubsid="59941167";
var prodsubid= "59940439";

function loadSavedData(){
	var usecloud=localStorage.getItem("useCloudSync");
	var cloudSyncUsername=localStorage.getItem("cloudSyncUsername");
	var cloudSyncPassword=localStorage.getItem("cloudSyncPassword");

	console.log("usecloud: "+usecloud);
	if(usecloud!=null)
		document.getElementById('cloudswitch').setChecked((usecloud == "true"));
	if(cloudSyncUsername!=null)
		$('#email').val(cloudSyncUsername);
	if(cloudSyncPassword!=null)
		$('#password').val(cloudSyncPassword);
	
	updatecloudstatus();
}
function changecloudstatus(){
	var check=document.getElementById('cloudswitch').getChecked();
	console.log("changecloudstatus: "+check);

	/*
	if(check){
		$('#Spinner').show();
		setTimeout(function(){
			checkSubscription();
		}, 500);
	}else{
		updatecloudstatus();
	}
	*/
	updatecloudstatus();
}

function updatecloudstatus(){
	document.getElementById('cloudswitch').onchange = null;
	
	localStorage.setItem("useCloudSync", document.getElementById('cloudswitch').getChecked());
	var check=document.getElementById('cloudswitch').getChecked();
	console.log("check: "+check);
	if(check){
		$('#textrow').show();
		$('#loginform').show();
	}else{
		$('#textrow').hide();
		$('#loginform').hide();
	}
	document.getElementById('cloudswitch').onchange = changecloudstatus;
}
function doSyncLogin(){
	var email=$.trim($('#email').val());
	var pass=$.trim($('#password').val());
	//validity.valid
	if(email!="" && pass!=""){
		$('#Spinner').show();
		console.log("validating: "+email+" "+pass);
		cloudsync.dispatchOK=function(){
			console.log("login ok dispached");

			localStorage.setItem("useCloudSync", document.getElementById('cloudswitch').getChecked());
			localStorage.setItem("cloudSyncUsername", email);
			localStorage.setItem("cloudSyncPassword", pass);
			$('#Spinner').hide();
			Toast.regular($.localize.data['app'].cloudsyncactivated, 2000);
			loadSavedData();
		};
		cloudsync.dispatchKO=function(){
			$('#Spinner').hide();
			console.log("login ko dispached");
			Toast.regular($.localize.data['app'].cloudsyncerrorlogin, 2000);
		};
		cloudsync.login(email, pass);
	}	
}

function resetPassword(){
	var email=$.trim($('#email').val());
	var pass=$.trim($('#password').val());
	
	if(email!=""){
		$('#Spinner').show();
		cloudsync.dispatchOK=function(){
			$('#Spinner').hide();
			Toast.regular($.localize.data['app'].passwordreseted, 2000);
		};
		cloudsync.dispatchKO=function(){
			$('#Spinner').hide();
			Toast.regular($.localize.data['app'].errorresetingpassword, 2000);

		};
		cloudsync.resetPassword(email);
	}else{
		Toast.regular($.localize.data['app'].addyouremailtosendpassword, 2000);
	}
	
}
function changePassword(){
	var email=$.trim($('#email').val());
	var pass=$.trim($('#password').val());
	if(email!="" && pass!=""){
		blackberry.ui.dialog.standardAskAsync($.localize.data['app'].insertnewpassword, blackberry.ui.dialog.D_PROMPT, function(selection){
			if(selection['return']=="Ok" && selection.promptText!=null){
				var pass1=selection.promptText;
				blackberry.ui.dialog.standardAskAsync($.localize.data['app'].typepasswordagain, blackberry.ui.dialog.D_PROMPT, function(selection){
					if(selection['return']=="Ok" && selection.promptText!=null){
						var pass2=selection.promptText;
						if(pass1==pass2){
							$('#Spinner').show();
							cloudsync.dispatchOK=function(){
								$('#Spinner').hide();
								Toast.regular($.localize.data['app'].passwordchanged, 2000);
							};
							cloudsync.dispatchKO=function(){
								$('#Spinner').hide();
								Toast.regular($.localize.data['app'].loginwrong, 2000);
							};
							cloudsync.changepass(email, pass, pass1);
						}else{
							Toast.regular($.localize.data['app'].passwordsdontmatch, 2000);
						}
					}
				}, {title : $.localize.data['app'].confirmpassword});
				
			}
		}, {title : $.localize.data['app'].newpassword});
		
	}else{
		Toast.regular($.localize.data['app'].filltheform, 2000);
	}
}

function getSyncBooksList(){
	$('#Spinner').show();
	cloudsync.onBooksLoaded=function(books){
		console.log(books);

		if(books.length==0){
			Toast.regular($.localize.data['app'].nobooksinaccount, 2000);
		}
		for(var i in books){
			var book=books[i];
			var item = document.createElement('div');
			item.setAttribute('data-bb-type','item');
			item.setAttribute('data-bb-title', book.title);
			item.setAttribute('data-bb-img', 'assets/epub.png');
			item.innerHTML=book.author;
			item.setAttribute('bookid', book.bookid);
			item.setAttribute('id', book.id);
			
			document.getElementById('booksynclist').appendItem(item);
		}
		$('#Spinner').hide();
	};
	cloudsync.dispatchKO=function(){
		$('#Spinner').hide();
		Toast.regular($.localize.data['app'].errorconnecting, 2000);
	};
	cloudsync.getBookList();
}

function deleteBook(){
    var context = document.getElementById('contextlist');
	var selected=context.menu.selected.selected;
	console.log(selected);
	var bookid=selected.getAttribute("bookid");
	var ids=[selected.getAttribute("id")];
	blackberry.ui.dialog.standardAskAsync($.localize.data['app'].sureremovebookfromcloud, blackberry.ui.dialog.D_OK_CANCEL, function(selection){
		if(selection['return']=="Ok"){
			$('#Spinner').show();
			cloudsync.dispatchOK=function(){
				$('#Spinner').hide();
				Toast.regular($.localize.data['app'].bookremoved, 2000);
				selected.remove();
			};
			cloudsync.dispatchKO=function(){
				$('#Spinner').hide();
				Toast.regular($.localize.data['app'].loginwrong, 2000);
			};
			cloudsync.delBook(bookid, JSON.stringify(ids));
		}
	}, {title : $.localize.data['app'].removebook});
}

function openSavedBooksScreen(){
	var usecloud=localStorage.getItem("useCloudSync");
	var cloudSyncUsername=localStorage.getItem("cloudSyncUsername");
	var cloudSyncPassword=localStorage.getItem("cloudSyncPassword");
	var usecloud2=document.getElementById('cloudswitch').getChecked();
	
	if(usecloud2 && usecloud=="true" && cloudSyncUsername!=null && cloudSyncPassword!=null){
		bb.pushScreen('settingsCloudSyncSavedBooks.html', 'settingscloudsavedbooks');
	}else{
		Toast.regular($.localize.data['app'].havetobesubscribedbooks, 3000);
	}
}
/*
InAPP 
*/
function updateViewAfterSubscription(){
	document.getElementById('cloudswitch').setChecked(false);
	updatecloudstatus();
}
function checkSubscription() {
    try {
        blackberry.payment.checkExisting({
            id: testsubsid
        }, function(data){
        	console.log(data);
        	var isSubscribed=data.subscriptionExists;
        	if(!isSubscribed){
        		purchase();
        	}else{
        		$('#Spinner').hide();
        		updatecloudstatus();
        		Toast.regular($.localize.data['app'].havetobesubscribed, 3000);
        	}
        }, function(error){
        	console.log(error);
        	$('#Spinner').hide();
            Toast.regular($.localize.data['app'].errorcheckingsubscription, 3000);
            updateViewAfterSubscription();
        });
    } catch (e) {
        alert ("Error" + e);
    }
}

function cancelSubscription() {
    try {
        blackberry.payment.cancelSubscription("59940439", 
        function(data){
        	$('#Spinner').hide();
            Toast.regular($.localize.data['app'].subscriptioncancelled, 3000);
            updateViewAfterSubscription();
        }, function(error){
        	console.log(error);
        	$('#Spinner').hide();
            Toast.regular($.localize.data['app'].errorcancelingsubscription, 3000);
            updateViewAfterSubscription();
        });
    } catch (e) {
        console.log(e);
    }
}

function purchase() {
    try {
        blackberry.payment.purchase({
		    "digitalGoodID": testsubsid,
		    "digitalGoodName":"SomeName",
		    "metaData":"metadata"
		},
		function(purchasedItem) {
			console.log(purchasedItem);
			//checkSubscription();
			$('#Spinner').hide();
			document.getElementById('cloudswitch').setChecked(true);
			updatecloudstatus();
            Toast.regular($.localize.data['app'].subscribed, 3000);
		}, 
		function (error) {
			console.log(error);
        	$('#Spinner').hide();
            Toast.regular($.localize.data['app'].errorsubscribing, 3000);
            updateViewAfterSubscription();
		});
	} catch (e) {
		alert ("Error" + e);
	}
}
