var autofolders=[];
function loadSettings(){
	var folder=localStorage.getItem("librariesDownloadFolder");
	if(!folder){
		folder=blackberry.io.sharedFolder+"/books";
	}
	if(folder.indexOf(blackberry.io.sharedFolder==0)){
		var pos=folder.indexOf("/share");
		folder=folder.substring(pos);
	}
	if(folder.indexOf("/accounts/1000/appdata"==0)){
		var pos=folder.indexOf("/share");
		folder=folder.substring(pos);
	}
	if(folder.indexOf("/accounts/1000/removable"==0)){
		folder=folder.replace("/accounts/1000/removable", "");
	}
	$('#saveDownloadFolder').html(folder);
	
	var autos=localStorage.getObject("automaticFolders");
	if(autos){
		autofolders=autos;
		paintAutoFolders();
	}
	
	var autoopen=localStorage.getItem("autolibraryopen");
	document.getElementById("libraryopen").setChecked((autoopen == "true"));
}
function autolibraryopen(){
	console.log("autolibraryopen", document.getElementById("libraryopen").getChecked());
	localStorage.setItem("autolibraryopen", document.getElementById("libraryopen").getChecked());
}
function paintAutoFolders(){
	for(var i=0; i<autofolders.length; i++){
		var url=autofolders[i];
		if(url.indexOf("/accounts/1000/appdata"==0)){
			var pos=url.indexOf("/share");
			url=url.substring(pos);
		}
		if(url.indexOf("/accounts/1000/removable"==0)){
			url=url.replace("/accounts/1000/removable", "");
		}
		$('#savelist').append( "<div>"+url+"</div>" );
		
		var button = document.createElement('div');
		button.setAttribute('data-bb-type','button');
		button.setAttribute('data-bb-style', 'stretch');
		button.setAttribute('url', autofolders[i]);
		button.innerHTML = 'Remove';
		button.onclick = function() {
			var url=this.getAttribute('url');
			removeAutomaticFolder(url);
		};
		button = bb.button.style(button);
		document.getElementById('savelist').appendChild(button);
	}
	bb.refresh();
}
function removeAutomaticFolder(url){
	for(var i=0; i<autofolders.length; i++){
		if(autofolders[i]==url){
			autofolders.splice(i, 1);
			break;
		}
	}
	localStorage.setObject("automaticFolders", autofolders);
	$('#savelist').empty();
	paintAutoFolders();
}
function changeLibraryDownloadFolder(){
	var folder=localStorage.getItem("librariesDownloadFolder");
	if(!folder){
		folder=blackberry.io.sharedFolder+"/books";
	}
	blackberry.invoke.card.invokeFilePicker(
			{
				mode: blackberry.invoke.card.FILEPICKER_MODE_SAVER_MULTIPLE,
				directory: [folder]
			},
			function (path) {
				$('#saveDownloadFolder').html(path[0]);
				localStorage.setItem("librariesDownloadFolder", path[0]);
			},
			function (reason) {
				console.log('User Cancelled: ' + reason);
			},
			function (error) {
				if (error) {
					console.log('Invoke Error: ' + error);
				}
			}
		);
}

function changeAutomaticFolder(){
	blackberry.invoke.card.invokeFilePicker(
		{
			mode: blackberry.invoke.card.FILEPICKER_MODE_SAVER_MULTIPLE,
			directory: [blackberry.io.sharedFolder]
		},
		function (path) {
			for(var i=0; i<autofolders.length; i++){
				console.log(autofolders[i]+" == "+path[0]);
				if(autofolders[i]==path[0]){
					Toast.regular($.localize.data['app'].folderalreadyinautomatic, 2000);
					return;
				}
			}
			autofolders.push(path[0]);
			localStorage.setObject("automaticFolders", autofolders);
			$('#savelist').empty();
			paintAutoFolders();
		},
		function (reason) {
			console.log('User Cancelled: ' + reason);
		},
		function (error) {
			if (error) {
				console.log('Invoke Error: ' + error);
			}
		}
	);
}

function resetFactoryDefaults(){
    try {
        blackberry.ui.dialog.standardAskAsync($.localize.data['app'].sureresetsettings, blackberry.ui.dialog.D_OK_CANCEL, doResetFactoryDefaults, {title : $.localize.data['app'].resetsettings});
    } catch (e) {
        alert("Exception in standardDialog: " + e);
    }
}

function doResetFactoryDefaults(selection){
    console.log(selection);
    if(selection['return']=="Ok"){
    	$('#Spinner').show();
    	var l=localStorage.length-1;
    	for(var i=l; i>=0; i--){
    		var key=localStorage.key(i);
    		console.log("removing: "+key);
    		localStorage.removeItem(key);
    	}
    	localStorage.clear();
    	booksFolder.removeRecursively(removeComplete, removeComplete);
    }
}

function removeComplete(){
	setTimeout(function(){
		blackberry.app.exit();		
	}, 2000);
}