Feedly={
		callback:Function, 
		canceled:false,
		scope : "https://cloud.feedly.com/v3/",
		categories_url:"https://cloud.feedly.com/v3/categories",
		stream_url:"https://cloud.feedly.com/v3/streams/contents?unreadOnly=true&count=100&ranked=newest&streamId=",
		authorize_url : 'https://cloud.feedly.com/v3/auth/auth?response_type=code&client_id=playepub&redirect_uri=http://playepub.com/feedly.html&scope=https://cloud.feedly.com/subscriptions&state=login',
		access_token_url : 'https://cloud.feedly.com/v3/auth/token',
		markread_url : 'https://cloud.feedly.com/v3/markers',
		_key:"playepub",
		_secret:"FE017KYB70MSTSVLGL6FEPSUO5GB",
		accessToken:null,
		refreshToken:null,
		expiresToken:0,
		identifier:"Feedly",
		
		init:function(){
			this.accessToken=localStorage.getItem("feedly_token");
			this.refreshToken=localStorage.getItem("feedly_refresh");
			this.expiresToken=localStorage.getItem("feedly_expires");
		},
		isLogged: function(){
			return (this.accessToken!=null);
		},
		clean: function(){
			localStorage.setItem("feedly_token", null);
			localStorage.setItem("feedly_refresh", null);
			localStorage.setItem("feedly_expires", null);
			this.accessToken=null;
		},
		auth: function(){
			if(!this.accessToken){
				this.requestTokenHandler();
			}else{
				this.authOK();
			}
		}, 
		authOK: function(){
			
		},
		authKO: function(){
			
		},
		syncComplete: function(){
			
		},
		_consumer:null,
		getConsumer: function() {
			if ( this._consumer == null ) {
				if ( this._key != null && this._secret != null )
					_consumer = new OAuthConsumer( _key, _secret );
				else
					throw new Error( "consumerKey/Secret not set." );
			}
			return _consumer;
		},
		wk:null, 
		requestTokenHandler: function(){
			 this.wk = window.open(this.authorize_url, '_blank');
			 console.log(this.wk);
			window.int = self.setInterval(function() {
				if(Feedly.wk.window){
					var currentURL = Feedly.wk.window.location.href;

					console.log(currentURL);
					var callbackURL = "http://playepub.com/feedly.html";
					var inCallback = currentURL.indexOf(callbackURL);
	
					if (inCallback == 0) {
						window.clearInterval(int);
						
						var url=currentURL.replace(callbackURL+"?", "");
						var temp=url.split("&");
						//oauth_verifier=owji4Bii6jzQwvZN0nHbAlv8&oauth_token=4%2FMyIYvd3EaiNFnVEJGoae1VjVxEiH
						var temp1=temp[0].split("=");
						var oauth_verifier=unescape(temp1[1]);
						Feedly.wk.close();
						Feedly.getAccessToken(oauth_verifier);
					}
				}else{
					//ventana cerrada
					window.clearInterval(int);
					Feedly.authKO();
				}
			}, 1000);

			//wk.addEventListener(NetworkResourceRequestedEvent.NETWORK_RESOURCE_REQUESTED, resourceRequest);
			//wk.addEventListener(WebViewEvent.DOCUMENT_LOADED, loaded);
		},

		getAccessToken: function(pin){
			//trace("getAccessToken: "+pin);
			
			 $.ajax({
				 type: 'POST',
				 url: this.access_token_url,
				 data: { 
				        'code': pin, 
				        'client_id': this._key,
				        'client_secret': this._secret,
				        'redirect_uri': "http://playepub.com/feedly.html",
				        'state': "KAKA",
				        'grant_type': "authorization_code",
				    },
				 
				 success: function(data) {
					 console.log(data);
					 Feedly.accessTokenHandler(data);
				 },
				 error: function(data) {
					 console.log('Error updating status: ' + data.responseText);
					 Feedly.authKO();
				 }
			});
			
		},
		
		accessTokenHandler: function(o){
			var d=new Date();
			this.accessToken=o.access_token;
			//userid=o.id;
			this.expiresToken=o.expires_in*1000+d.time;
			this.refresh_token=o.refresh_token;
			//plan=o.plan;
				
			localStorage.setItem("feedly_token", this.accessToken);
			localStorage.setItem("feedly_refresh", this.refresh_token);
			localStorage.setItem("feedly_expires", this.expiresToken);


			this.authOK();
		},
		
		verifyAccessToken: function(token){
		},
		listAll: function(){
			var now=new Date();
			if(this.expiresToken<now.time){
				this.doRefreshToken();
			}else{
				this.listAllOK();
			}
		},
		listAllOK:function(){
			 $.ajax({
				 type: 'GET',
				 url: this.categories_url,
				 headers: {
				    "Authorization": this.accessToken
				  },
				 success: function(data) {
					 console.log(data);
					 Feedly.listAllCategoriesOK(data);
				 },
				 error: function(data) {
					 console.log('Error updating status: ' + data.responseText);
					 Feedly.authKO();
				 }
			});
		},
		
		categories:[],
		currentCat:0,
		articles:[],
		listAllCategoriesOK: function(cats){
			//cats:Object=JSON.parse(data);
			if(cats instanceof Array){
				this.currentCat=0;
				this.categories=cats;
				this.articles=[];
				this.doCat();
			}else{
				this.syncComplete();
			}
		},
		doCat: function(){
			console.log("doCat");
			if(this.currentCat<this.categories.length){
				var o=this.categories[this.currentCat];
				var d=new Date();
				var stamp=d.time-(7*24*60*60*1000);
				
				 $.ajax({
					 type: 'GET',
					 url: this.stream_url+o.id+"&newerThan="+stamp,
					 headers: {
						    "Authorization": this.accessToken
						  },
					 success: function(data) {
						 //console.log(data);
						 Feedly.getStreamOK(data);
					 },
					 error: function(data) {
						 console.log('Error updating status: ' + data.responseText);
						 Feedly.authKO();
					 }
				});
			}else{
				if(this.articles.length>0){
					var myids=[];
					for(c in this.categories){
						myids.push(this.categories[c].id);
					}
					this.markAsRead(myids);
				}
				this.savebook();
			}
		},
		getStreamOK: function(o){
			var items=o.items;
			if(items.length>0){
				var cat=this.categories[this.currentCat];
				var o={};
				o.content="";
				o.title=cat.label;
				o.published=null;
				o.isCat=true;
				this.articles.push(o);
				for(var i in items){
					var item=items[i];
					o={};
					if(item.content)
						o.content=item.content.content;
					else
						o.content=item.summary.content;
					o.title=item.title;
					var published=new Date();
					published.time=item.published;
					o.published=published;
					//var df = new DateTimeFormatter(LocaleID.DEFAULT, DateTimeStyle.MEDIUM, DateTimeStyle.NONE);
					//var currentDate = new Date();
					//shortDate = df.format(currentDate);
					//o.fecha=shortDate;
					o.originId=item.originId;
					o.feedurl=item.origin.htmlUrl;
					o.feedtitle=item.origin.title;
					o.isCat=false;
					this.articles.push(o);
				}				
			}
		    this.currentCat++;
			this.doCat();
		},
		savebook:function(){
			if(!this.canceled && this.articles.length>0){
				var images=localStorage.getItem("reditlater_download_images");
				
				var book=new NewBook("Feedly", "Feedly", "");
				book.setCover("local://assets/coverfeedly.png");
				book.setBooksFolder(booksFolder);
				book.setDownloadImages((images == "true"));
				var ident="          ";
				var order=0;
				
				for(var i in this.articles){
					//						if(!canceled){
					var o=this.articles[i];
					var file={};
					if(o.isCat){
						file.title=o.title;
						file.url="";
						file.html='<html><head><meta charset=\"UTF-8\"><title></title></head><body><div><h1>'+o.title+'</h1></div></body></html>';
						file.id="file"+order+".html";
						file.contentType="text/plain";
						
						var temp={};
						temp.src=file.id;
						temp.label=o.title;
						temp.playOrder=order;
						temp.size=file.html.length;
						
						book.addSpine(temp);
					}else{
						content='<html><head><meta charset="UTF-8"><title></title></head><body><h2><a href="'+o.originId+'">'+o.title+'</a></h2><div><p><a href="'+o.feedurl+'">'+o.feedtitle+'</a><br/>'+o.fecha+'</p></div><div>'+o.content+'</div></body></html>';
						content=this.cleancontent(content);
						file.title=ident+o.title;
						file.url=o.feedurl;
						file.html=content;
						file.id="file"+order+".html";
						file.contentType="text/plain";
						
						temp.label=ident+o.title;
						book.addSpine(temp);
					}
					
					book.addFile(file);
					order++;
				}
				book.creationComplete=function(){
					Feedly.syncComplete();
				};
				book.createBook();
			}else{
				this.syncComplete();
			}
		},
		cleancontent:function(s){
			var q;
			var temp="";
			var p=s.indexOf("<iframe");
			if(p>=0){
				q=s.indexOf("</iframe>", p);
				if(q>=0){
					temp+=s.substr(0, p);
					temp+=s.substr(q+9);
					s=this.cleancontent(temp);
				}
			}
			return s;
		},

		markAsRead: function(ids){
			console.log(ids);
			 var o={ 
				        'action': "markAsRead", 
				        'type': "categories",
				        'categoryIds': ids
				    }; 
			var mydata=JSON.stringify(o);
			console.log(o);
			console.log(mydata);
			
			 $.ajax({
				 type: 'POST',
				 url: this.markread_url,
				 data: mydata,
				 contentType: "application/json",
				 headers: {
					    "Authorization": this.accessToken
					  },
				 success: function(data) {
					 console.log(data);
				 },
				 error: function(data) {
					 console.log('Error updating status: ' + data.responseText);
					 Feedly.authKO();
				 }
			});
			//request.contentType="application/json";
		},
		doRefreshToken: function(){
			 $.ajax({
				 type: 'POST',
				 url: this.access_token_url,
				 data: {
					 "refresh_token": this.refresh_token, 
					 "client_id": this._key,
					 "client_secret": this._secret,
					 "grant_type":  "refresh_token"
				 },

				 headers: {
					    "Authorization": this.accessToken
					  },
				 success: function(data) {
					 Feedly.doRefreshTokenOK(data);
				 },
				 error: function(data) {
					 console.log('Error updating status: ' + data.responseText);
					 Feedly.authKO();
				 }
			});
		},
		doRefreshTokenOK:function(resp){
			var o=JSON.parse(resp);
			this.accessToken=o.access_token;
			var d=new Date();
			this.expiresToken=o.expires_in*1000 + d.time;
			
			localStorage.setItem("feedly_token", this.accessToken);
			localStorage.setItem("feedly_expires", this.expiresToken);
			this.listAllOK();
		},
		cancel:function(){
			this.canceled=true;
		}
};