function loadLibrariesAdd(){
	var data=localStorage.getObject("libraries");
	if(data && data.length>0){
		libraries=data;
	}else{
		libraries.push({id: 0, label: "Gutenberg.org", url: "http://m.gutenberg.org/ebooks.opds/", isOPDS: true, search: "http://m.gutenberg.org/ebooks/search.opds/?query={searchTerms}"});
		libraries.push({id: 1, label: "Feedbooks.org", url: "http://www.feedbooks.com/site/free_books.atom", isOPDS: true, search: "http://www.feedbooks.com/search.atom?query={searchTerms}"});
		libraries.push({id: 3, label: "ManyBooks", url: "http://manybooks.net/opds/index.php", isOPDS: true, search: ""});//http://manybooks.net/opds/search.php?q={searchTerms}
		libraries.push({id: 4, label: "EpubBud", url: "http://www.epubbud.com/feeds/catalog.atom", isOPDS: true, search: "http://www.epubbud.com/search.php?q={searchTerms}&p=0&format=atom"});
		libraries.push({id: 5, label: "Internet Archive Catalog", url: "http://bookserver.archive.org/catalog/", isOPDS: true, search: "http://bookserver.archive.org/catalog/opensearch?q={searchTerms}&start=0"});
		libraries.push({id: 6, label: "All Romance Books", url: "http://www.allromanceebooks.com/epub-feed.xml", isOPDS: true, search: "http://www.allromanceebooks.com/epub-feed.xml?search={searchTerms}"});
		libraries.push({id: 9, label: "Revues.org", url: "http://bookserver.revues.org/", isOPDS: true, search: "http://search.openedition.org/?q={searchTerms}"});
		libraries.push({id: 10, label: "Ebooks Gratuits", url: "http://www.ebooksgratuits.com/opds/", isOPDS: true, search: "http://www.ebooksgratuits.com/opds/feed.php?mode=search&query={searchTerms}"});
		libraries.push({id: 11, label: "Atramenta", url: "http://www.atramenta.net/opds/lecture_libre.atom", isOPDS: true, search: ""});
		libraries.push({id: 13, label: "Ganso y pulpo", url: "http://www.gansoypulpo.com/opds/inicio.atom", isOPDS: true, search: "http://opds.gansoypulpo.com/feed/atom/s={searchTerms}"});
		libraries.push({id: 13, label: "Filibusta", url: "http://flibusta.net/opds", isOPDS: true, search: "http://flibusta.net/opds/search?searchTerm={searchTerms}"});
	}
	console.log(libraries);
}
function loadLibraries(){
	libraries=[];
	loadLibrariesAdd();
	window.removeEventListener('contextmenu', onLibraryContextMenu);
	
	var items = [],
    item;
	var l=libraries.length;
	for(var i=0; i<l; i++){
		var libr=libraries[i];
		item = document.createElement('div');
		item.setAttribute('data-bb-type','item');
		item.setAttribute('data-bb-title', libr.label);
		item.innerHTML = libr.url;
		if(libr.isOPDS)
			item.setAttribute('data-bb-img','assets/item_download.png');
		else
			item.setAttribute('data-bb-img','assets/white/link_go32.png');
		
		item.setAttribute('id',libr.id);
		item.setAttribute('url',libr.url);
		item.setAttribute('isOPDS',libr.isOPDS);
		item.setAttribute('label',libr.label);
		item.onclick = clickLibrary;
		items.push(item);
	}
	console.log(items);
	document.getElementById('librarieslist').refresh(items);
}

function addLibrary(){
	bb.pushScreen("librariesAdd.html", "librariesAdd");
}
function doAddLibrary() {
	var name = $('#name').val();
	var url = $('#url').val();

	if (name != "" && url != "" && (url.indexOf("http://") == 0 || url.indexOf("https://") == 0)) {
		$('#Spinner').show();
		var lib = {};
		lib.label = name;
		lib.url = url;
		lib.id = new Date().getTime();
		lib.isOPDS=false;

		//test for opds
		var done=false;
		OPDS.access(url, function(catalog){
			if(!done){
				done=true;
				if(catalog){
					lib.isOPDS=true;
					console.log("ES OPDS");
				}
				saveNewLibrary(lib);
			}			
		});
		/*
		$.ajax({
			type : "GET",
			url : url,
			type: "xml",
			success : function(xml) {
				console.log(xml);
				   $(xml).find('link').each(function(){
					   console.log($(this));
					    if($(this).attr('type')=='application/atom+xml;type=entry;profile=opds-catalog' || $(this).attr('type')=='application/atom+xml;profile=opds-catalog' || $(this).attr('type')=='application/atom+xml;profile=opds-catalog;kind=navigation') {
					       // is opds
					    	lib.url=$(this).attr('href');
							lib.isOPDS=false;
							console.log("IS OPDS "+lib.url);
					    } else {
					    }
					});
					saveNewLibrary(lib);
			},
			error : function() {
				console.log("ERROR LOADING");
				saveNewLibrary(lib);
			}
		});
		*/
	}
}
function saveNewLibrary(lib){
	$('#Spinner').hide();
	libraries.push(lib);
	saveLibraries();
	bb.popScreen();
}
function clickLibrary(){
	var selected = document.getElementById('librarieslist').selected;
	var url=selected.getAttribute("url");
	var label=selected.getAttribute("label");
	var isOPDS=selected.getAttribute("isOPDS");
	console.log(url);
	if(isOPDS=="true"){
		bb.pushScreen("librariesOPDS.html", "librariesOPDS", {label:label, url:url});
	}else{
	    // open web link in browser
	    blackberry.invoke.invoke({
	        target: "sys.browser",
	        uri: url
	    }, function(){}, function(){});
	}
}
function goToLibrary(){
    var context = document.getElementById('contextlist');
	var selected=context.menu.selected.selected;
	var isOPDS=selected.getAttribute("isOPDS");
	var label=selected.getAttribute("label");
	var url=selected.getAttribute("url");
	console.log(url);
	if(isOPDS=="true"){
		bb.pushScreen("librariesOPDS.html", "librariesOPDS", {label:label, url:url});
	}else{
	    // open web link in browser
	    blackberry.invoke.invoke({
	        target: "sys.browser",
	        uri: url
	    }, function(){}, function(){});
	}
}
function removeLibrary(){
    var context = document.getElementById('contextlist');
	var selected=context.menu.selected.selected;

	var id=selected.getAttribute("id");
	var l=libraries.length;
	for(var i=0; i<l; i++){
		var libr=libraries[i];
		if(libr.id==id){
			libraries.splice(i, 1);
			break;
		}
	}
	selected.remove();
	saveLibraries();
}
function saveLibraries(){
	localStorage.setObject("libraries", libraries);
}




function loadOPDS(params){
	if(params==null){
		document.getElementById('title').setCaption(opdsInitParams.label);
		reloadLastState();
	}else{
		searchUrl=null;
		var l=libraries.length;
		console.log(libraries);
		
		for(var i=0; i<l; i++){
			if(libraries[i].url==params.url && libraries[i].search!=""){
				searchUrl=libraries[i].search;
				document.getElementById('searchButton').show();
				break;
			}else{
				document.getElementById('searchButton').hide();
			}
		}
		
		opdsInitParams=params;
		historyLibrary=[];
		document.getElementById('title').setCaption(params.label);
		$('#Spinner').show();
		isLoadingNextPage=false;
		loadOPDSUrl(params.url);
	}
	updateNavigationButtons();
	//window.addEventListener('contextmenu', onLibraryContextMenu);
}

function scrollingList(){
	if(lastListElement!=null && bb.isScrolledIntoView(lastListElement)){
		console.log("IS NOW IN SCROLL");
		if(NextURL!=null){
			loadNextPage();
		}
	}
}
function onLibraryContextMenu(e){
	var selected=e.srcElement.parentElement;
	var id=parseInt(selected.getAttribute("itemID"));
	var item=historyLibrary[historyPunt].items[id];

console.log(item);
	document.getElementById('epubaction').hide();
	document.getElementById('pdfaction').hide();
	document.getElementById('kindleaction').hide();
	if(item.downloads.length==0){
		//document.getElementById('showaction').hide();
		console.log("OCULTO EXTENSIONES");
	}else{
		for(var i=0; i<item.downloads.length; i++){
			if(item.downloads[i].type=="epub"){
				console.log("epub");
				document.getElementById('epubaction').show();
			}
			//if(item.downloads[i].type=="pdf"){
			//	console.log("pdf");
			//	document.getElementById('pdfaction').show();
			//}
			if(item.downloads[i].type=="kindle"){
				console.log("kindle");
				document.getElementById('kindleaction').show();
			}
		}
	}
}

/*
function showBookDetails(){
	console.log("showBookDetails");
    var context = document.getElementById('contextlist');
	var selected=context.menu.selected.selected;
	var id=parseInt(selected.getAttribute("itemID"));
	var item=historyLibrary[historyPunt].items[id];
	console.log(item);
	isLoadingNextPage=false;
	//if(item.author){
	//	bb.pushScreen("librariesOPDSdetail.html", "librariesOPDSdetail", item);
	//}else{
		loadOPDSUrl(item.url);
	//}
	
}
*/
function changeOPDSUrl(){
	var selected = document.getElementById('librarieslist').selected;
	var url=selected.getAttribute("url");
	var id=parseInt(selected.getAttribute("itemID"));
	var item=historyLibrary[historyPunt].items[id];
	
	console.log(item);
	if(item.downloads && item.downloads.length>0){
		bb.pushScreen("librariesOPDSdetail.html", "librariesOPDSdetail", item.entry);	
	}else{
		loadOPDSUrl(url);
	}
}

function loadOPDSUrl(url){
	console.log(url);
	$('#Spinner').show();
	NextURL=null;
	
	OPDS.access(url, function(catalog){
		$('#Spinner').hide();
		if(catalog){
			var items=[];
			var breakprocessing=false;
			//document.getElementById('title').setCaption(catalog.title);
		    _.each(catalog.entries, function(link){
		    	console.log(link);
		    	console.log(link.acquisitionLinks());
		    	var item={};
		    	
	    		item.title=link.title;

	    		item.author = "";
	    		if(link.authors.length>0){
	    			var autor="";
	    			for(var i=0; i<link.authors.length; i++){
	    				if(autor!="")
	    					autor+=", ";
	    				var au=link.authors[i];
	    				autor+=au.name;
	    			}
    				item.author=autor;
	    		}else if(link.author && link.author!=undefined && link.author.name!=null){
	    			item.author=link.author.name;
	    		}
	    		if(link.symmary!=null)
	    			item.innerHTML = link.summary;
	    		else if(link.content!=null)
	    			item.innerHTML = link.content;
	    		else
	    			item.innerHTML="";
	    		
	    		var image=false;
	    		var hasLink=false;
				item.downloads=[];
				
    			for(var i=0; i<link.links.length; i++){
    				if(link.links[i].type.indexOf('application/atom+xml;profile=opds-catalog')==0 || link.links[i].type.indexOf('application/atom+xml')==0){
    					if(link.links[i].rel!="start" && link.links[i].rel!="self"){
	    	    			item.url=link.links[i].url.replace(" ", "");
	    	    			hasLink=true;
    					}
    				}
    				if(link.links[i].type=="image/png" || link.links[i].type=="image/gif" || link.links[i].type=="image/jpg" || link.links[i].type=="image/jpeg"){
    					image=true;
    					
    					if(link.links[i].rel=="http://opds-spec.org/image"){
    						item.image=link.links[i].url;
    					}
    					if(link.links[i].rel=="http://opds-spec.org/image/thumbnail" || link.links[i].rel=="http://opds-spec.org/thumbnail"){
    						item.thumbnail=link.links[i].url;
    					}
    				}
    				if(link.links[i].type=="application/epub+zip"){
    					item.downloads.push({type:"epub", url:link.links[i].url});
    				}
    				if(link.links[i].type=="application/x-mobipocket-ebook"){
    					item.downloads.push({type:"kindle", url:link.links[i].url});
    				}
    			}
				if(!hasLink){
					item.url=link.id;
				}
	    		if(!image)
		    		item.image='assets/item_download.png';
	    		item.entry=link;
	    		items.push(item);
		    });	
		    
		    var next="";
		    NextURL=null;
		    _.each(catalog.links, function(link){
				console.log(link);
		    	//pagina siguiente
		    	if (link.rel=="next"){
		    		console.log("NEXT: "+link.url);
		    		next=link.url;
		    		NextURL=next;
		    	}
		    	//si tiene links de descarga estoy en el detalle del libro, aborto y voy a detalle
				if(link.type=="application/epub+zip" || link.type=="application/x-mobipocket-ebook"){
					breakprocessing=true;
				}
		    });
		    if(!breakprocessing){//si no voy a detalle
			    if(!isLoadingNextPage){
			    	if(historyPunt!=(historyLibrary.length-1)){
			    		historyLibrary.splice(historyPunt, historyLibrary.length-historyPunt);
			    	}
			    	historyLibrary.push({url: url, items: items, next: next});
			    	historyPunt=historyLibrary.length-1;
			    }
			    addItems(items);
		    }else{
		    	bb.pushScreen("librariesOPDSdetail.html", "librariesOPDSdetail", catalog);		    	
		    }
		}else{
			$('#Spinner').hide();
			Toast.regular($.localize.data['app'].errorloadingcatalog, 3000);
		}
	});
}
function loadNextPage(){
	isLoadingNextPage=true;
	loadOPDSUrl(NextURL);
}

function addItems(items){
	var listitems=[];
	for(var i=0; i<items.length; i++){
		var link=items[i];
		item = document.createElement('div');
		item.setAttribute('data-bb-type','item');
		item.setAttribute('data-bb-title', link.title);
		if(link.author!=""){
			item.innerHTML = link.author;
		}else{
			item.innerHTML = link.innerHTML;
		}
		if(link.thumbnail){
			item.setAttribute('data-bb-img', link.thumbnail);
		}else if(link.image){
			item.setAttribute('data-bb-img', link.image);
		}
		item.setAttribute('url',link.url);
		item.setAttribute('itemID',i);
		item.onclick = changeOPDSUrl;
		listitems.push(item);
	}
	lastListElement=listitems[listitems.length-1];
	if(!isLoadingNextPage){
		lastLoadedItems=items;
		document.getElementById('librarieslist').refresh(listitems);
	}else{
		for(var i=0; i<listitems.length; i++){
			document.getElementById('librarieslist').appendItem(listitems[i]);
			lastLoadedItems.push(items[i]);
		}
		isLoadingNextPage=false;
	}
		
	updateNavigationButtons();
    console.log(historyLibrary);
}
function reloadLastState(){
	var listitems=[];
	for(var i=0; i<lastLoadedItems.length; i++){
		var link=lastLoadedItems[i];
		item = document.createElement('div');
		item.setAttribute('data-bb-type','item');
		item.setAttribute('data-bb-title', link.title);
		if(link.author!=""){
			item.innerHTML = link.author;
		}else{
			item.innerHTML = link.innerHTML;
		}
		if(link.thumbnail){
			item.setAttribute('data-bb-img', link.thumbnail);
		}else if(link.image){
			item.setAttribute('data-bb-img', link.image);
		}
		item.setAttribute('url',link.url);
		item.setAttribute('itemID',i);
		item.onclick = changeOPDSUrl;
		listitems.push(item);
	}
	lastListElement=listitems[listitems.length-1];
	document.getElementById('librarieslist').refresh(listitems);
}
function reloadLibrary(){
	if(historyLibrary.length>0){
		document.getElementById('pantalla').scrollTo(0,0);
		var item=historyLibrary[historyPunt];
		historyLibrary.splice(historyPunt, historyLibrary.length-historyPunt);
		updateNavigationButtons();
		isLoadingNextPage=false;
		NextURL=null;
		loadOPDSUrl(item.url);
	}
}
function goPrevious(){
	if(historyLibrary.length>1 && historyPunt<historyLibrary.length && historyPunt>0){
		//historyLibrary.pop();//elimino el actual y cargo el anterior
		isLoadingNextPage=false;
		if(historyLibrary.length>0){
			NextURL=null;
			document.getElementById('pantalla').scrollTo(0,0);
			historyPunt--;
			var item=historyLibrary[historyPunt];
			console.log(item);
			addItems(item.items);
			updateNavigationButtons();
		}
	}
}
function goNext(){
	if(historyPunt<(historyLibrary.length-1)){
		isLoadingNextPage=false;
		NextURL=null;
		document.getElementById('pantalla').scrollTo(0,0);
		historyPunt++;
		var item=historyLibrary[historyPunt];
		console.log(item);
		if(item.next){
			NextURL=item.next;
		}
		addItems(item.items);
		updateNavigationButtons();	
	}
}
function updateNavigationButtons(){
	if(historyLibrary.length>1 && historyPunt>0){
		document.getElementById('prevbutton').setImage('assets/white/prev.png');
	}else{
		document.getElementById('prevbutton').setImage('assets/white/prevoff.png');
	}
	/*
	if(historyPunt<(historyLibrary.length-1)){
		document.getElementById('nextbutton').setImage('assets/white/next.png');
	}else{
		document.getElementById('nextbutton').setImage('assets/white/nextoff.png');
	}
	*/
}

function openSearch(){
	blackberry.ui.dialog.standardAskAsync($.localize.data['app'].texttosearch, blackberry.ui.dialog.D_PROMPT, function(selection){
		if(selection['return']=="Ok"){
			if(selection.promptText){
				var url=searchUrl.replace("{searchTerms}", selection.promptText);
				var uri = encodeURI(url);
				isLoadingNextPage=false;
				NextURL=null;
				loadOPDSUrl(uri);
			}
		}
	}, {title : "Search on library"});
}

/*
 * Funciones de downloads
 */

function showDownloads(){
	bb.pushScreen("librariesDownloads.html", "librariesDownloads");
}
function loadDownloads(){
	bb.screens[bb.screens.length-2].params=null;
	doLoadDownloads();
}
function doLoadDownloads(){
	var listitems=[];
	var item;
	for(var i=0; i<downloadItems.length; i++){
		var link=downloadItems[i];
		item = document.createElement('div');
		item.setAttribute('data-bb-type','item');
		item.setAttribute('data-bb-title', link.title);
		item.setAttribute('url', link.url);
		item.innerHTML = link.status;
		item.setAttribute('data-bb-img', link.image);
		item.setAttribute('id', "download"+link.id);
		listitems.push(item);
	}
	
	document.getElementById('librarieslist').refresh(listitems);
}
function cancelDownload(){
    var context = document.getElementById('contextlist');
	var selected=context.menu.selected.selected;
	var url=selected.getAttribute("url");
	for(var i=0; i<downloadItems.length; i++){
		if(downloadItems[i].url==url){
			console.log(downloadItems[i].ft);
			downloadItems[i].ft.abort(function(e){console.log(e);}, function(e){console.log(e);});
			console.log("canceled");
			break;
		}
	}
}
