function sizeToStr(bytes)
{
	var s = ['bytes', 'kb', 'MB', 'GB', 'TB', 'PB'];
	var exp = Math.floor(Math.log(bytes)/Math.log(1024));
	var str=(bytes / Math.pow(1024, Math.floor(exp))).toFixed(2) + " " + s[exp];
	return str;
}
function toArray(list) {
	return Array.prototype.slice.call(list || [], 0);
}


function getFileExtension(filename){
	filename=filename.toLowerCase(); 
	var pos=filename.lastIndexOf(".");
	if(pos>=0){
		return filename.substring(pos+1);
	}
	return "";
}

function getFileIdentifier(tempfile){
	var identifier=tempfile.replace("."+getFileExtension(tempfile), "");

	var myPattern = /\W/g; 
	identifier=identifier.replace(myPattern, "");
	myPattern = /\n/g; 
	identifier=identifier.replace(myPattern, "");
	myPattern = /\r/g; 
	identifier=identifier.replace(myPattern, "");
	myPattern = /\//g; 
	identifier=identifier.replace(myPattern, "");
	myPattern = /\\/g; 
	identifier=identifier.replace(myPattern, "");
	
	if(identifier==""){
		identifier=Base64.encode(tempfile).replace(/=/g, "");
	}
	return identifier;
}

